-*- coding: utf-8 -*-

base-url = https://github.com/ruby/ruby

commit 75d6b159eba73d4effe5989052f621177423e9db
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-04 20:37:32 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-03-04 21:12:58 +0900

    Always strictly align iseq compile data

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16301

commit d2516d32418e7414667d1e1cd16b02cc622e1881
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-03 23:48:27 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-03-04 21:12:58 +0900

    Calculate padding by alignment size

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16301

commit 795619ec11b9803f38a32edf1daba6557dddb149
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-03-04 20:49:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 20:49:58 +0900

    [ruby/prism] Revert "Reject infix operators on command call on
    writes"
    (https://github.com/ruby/prism/pull/3960)

    This reverts commit https://github.com/ruby/prism/commit/4e71dbfc7bd9.

    And also add a regression test. Seems like currently prism parses these the same that parse.y does.

    https://github.com/ruby/prism/commit/03993421f2

commit 4d7f3ba286f3bc67554417008d4707f014520ce6
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-13 08:12:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 20:02:36 +0900

    [ruby/mmtk] Cargo format

    https://github.com/ruby/mmtk/commit/7889da7c0e

commit 45dabe3382bc71fbb40ec60eb3eaa0e21de2564d
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-13 07:59:02 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 20:02:35 +0900

    [ruby/mmtk] Distribute batch candidates across parallel buckets

    Instead of sending all 128 buffered objects to one bucket,
    round-robin distribute them across all worker buckets so
    parallel obj_free work stays balanced.

    https://github.com/ruby/mmtk/commit/e1f926cd21

commit 3ec9bafea1a08eee3a8c76dc01d01ef0ba61f81c
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-13 07:40:01 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 20:02:35 +0900

    [ruby/mmtk] Flush obj_free buffers before shutdown finalizers

    shutdown_call_finalizer reads candidates from the Rust-side
    WeakProcessor, but the main ractor's C-side buffer may not
    have been flushed yet (ractor_cache_free runs later). Flush
    all remaining buffers before reading candidates.

    https://github.com/ruby/mmtk/commit/7e01232134

commit 092620090a3e639b223a7f03fbdfdd088d93a141
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-13 00:40:56 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 20:02:35 +0900

    [ruby/mmtk] Fix Cargo format issues

    https://github.com/ruby/mmtk/commit/26ec9f7f89

commit fa8b6aff710e97923cbf80ac8627b798cfe476e4
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-13 00:20:56 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 20:02:35 +0900

    [ruby/mmtk] Buffer obj_free candidates.

    Previously, every object allocation in rb_gc_impl_new_obj made a
    per-object FFI call into Rust (mmtk_add_obj_free_candidate), which
    acquired a mutex on one of the WeakProcessor's candidate vecs, pushed a
    single element, and released the mutex. That's an FFI crossing + mutex
    lock/unlock on every single allocation.

    Now, each MMTk_ractor_cache has two local buffers (parallel-freeable and
    non-parallel-freeable, 128 entries each). On allocation, we just store
    the pointer into the local buffer. When a buffer fills up, we flush the
    entire batch in one FFI call using mmtk_add_obj_free_candidates, which
    does a single mutex acquisition and extend_from_slice for the whole
    batch.

    We picked 128 as our buffer size at random. We should probably
    investigate further what an optimum size for this is

    https://github.com/ruby/mmtk/commit/23c4a9a676

commit d3b6bfe6f530cb5b4a03918bf12b0e6315c53513
  Author:     Andrii Furmanets <furmanets.andriy@gmail.com>
  AuthorDate: 2026-03-04 17:21:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 18:39:10 +0900

    [ruby/rubygems] Drop subprocess regression test for request proxy lookup

    https://github.com/ruby/rubygems/commit/fdae8c7698

commit d920d3995689cb2cc46c00d16cabaaaca5abfd6c
  Author:     Andrii Furmanets <furmanets.andriy@gmail.com>
  AuthorDate: 2026-03-03 01:54:29 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 18:39:09 +0900

    [ruby/rubygems] Fix Gem::Request proxy env lookup when required directly

    https://github.com/ruby/rubygems/commit/db8fd6becb

commit f57af84dba44365ef175026f0c8cb1bd52949c47
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2026-02-28 09:47:47 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 15:58:36 +0900

    [ruby/rubygems] Fix plugin new version not registering:

    - ### Problem

      When a plugin in the Gemfile is updated to a new version, it will
      be downloaded but will not be registered. The old version of the
      plugin will be loaded when Bundler is invoked.

      ### Context

      The problem is in the `Index#installed?` method that only checks for
      the plugin name in the index. If it finds one, it skips the
      registration.

      ### Solution

      Check whether the registed plugin load paths matche the new plugin
      one. If not, register the new plugin which will override the
      previous one in the index.

    https://github.com/ruby/rubygems/commit/ac65001055

commit 115b4c65440557eaa89c6ceadc39fe6eea1b984d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-03-04 15:50:58 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-03-04 15:51:37 +0900

    Add NEWS.md entry for ENV.fetch_values and that tests

    From https://github.com/ruby/ruby/pull/16289

    Co-authored-by: Suleyman Musayev <96992680+msuliq@users.noreply.github.com>

commit f604d1a879454f8cc807e31f65ee230327aae9de
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2026-03-03 08:50:48 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 11:24:52 +0900

    [ruby/rubygems] Update the man pages header to be in sync with the config one

    https://github.com/ruby/rubygems/commit/77def7f4e0

commit 5b6c6414cf7f1dbdcdc771192f5b2e124dbf61f3
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2026-03-03 08:29:23 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 11:24:51 +0900

    [ruby/rubygems] Add a new Bundler config to control how many specs are fetched:

    - ### Problem

      In #9071, I increased the API_REQUEST_SIZE constants to fetch 100
      specifications at once instead of 50.
      Worth to remember that this codepath is exclusively used for servers
      that don't implement the compact index API and where Bundler has to
      fallback on the `/v1/dependencies` endpoint.

      Fetching 100 gems at once seems not supported by some gem servers.
      See https://github.com/ruby/rubygems/issues/9345

      ### Solution

      I'd like to provide a new Bundler configuration
      `BUNDLE_API_REQUEST_SIZE` to let users of those servers control how
      many dependencies should be fetched at once.

      ### Alternatives

      The other alternative is to revert #9071 and always fetch 50 specs.
      I tried the number 100 on a single rubygem registry (cloudsmith),
      and I don't have data point to know whether this value is supported
      by most registries.

    https://github.com/ruby/rubygems/commit/1a3bace42e

commit 2be717ae7f3a8ca9063d3971bce541dec005a767
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-26 04:55:12 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-03-04 08:53:19 +0900

    Shrink struct rb_callinfo to 32 bytes

    This shouldn't do anything right now under the default GC, but in the
    future (or now on MMTK?) this would allow them to be allocated from a
    smaller size pool.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16250

commit f9c51ac5ea42382a22fb8a2cc5d7aeb78e77c962
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-03-04 08:01:30 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-03-04 08:01:30 +0900

    ZJIT: Fix Class type system bug and constant-fold IsA (#15268)

    Fix a some bugs in the type lattice around classes and user-defined classes. Refine types more precisely to subclasses of object.

    With that fix, add const-folding support for IsA.

    Co-authored-by: John Hawthorn <john.hawthorn@shopify.com>
    Co-authored-by: Luke Gruber <luke.gruber@shopify.com>

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit a88e2abb42687c038694b81df31c9baf296ddeeb
  Author:     Andrew Konchin <andry.konchin@gmail.com>
  AuthorDate: 2026-03-03 22:27:56 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2026-03-04 07:42:56 +0900

    Update to ruby/spec@af627d6

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16292

commit 6b6ceb97db47b7f7e6a91c21b8f5147ba5f751be
  Author:     Andrew Konchin <andry.konchin@gmail.com>
  AuthorDate: 2026-03-03 22:27:53 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2026-03-04 07:42:56 +0900

    Update to ruby/mspec@a2587d9

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16292

commit f46eb48b261a9289a463a29fbceaecf37ee860dd
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-03-03 23:28:03 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-03-04 06:00:57 +0900

    Expand the Shape heap index mask

    I think we have spare bits here, so let's expand them out and see what
    happens. This will allow us to have more than 7 size pools in the future

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16294

commit b2ff380d5ba0c966b3bfcd2fd05afd0934bfd84a
  Author:     ndossche <nora.dossche@ugent.be>
  AuthorDate: 2026-02-25 07:12:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-04 03:02:07 +0900

    [ruby/openssl] Fix memory leak if ossl_bn_new() fails

    When that call fails, the `bn` BIGNUM is never freed in
    asn1integer_to_num(). To solve this, use rb_protect().

    Example Valgrind report:
    ```
    32 (24 direct, 8 indirect) bytes in 1 blocks are definitely lost in loss record 11,113 of 25,910
      malloc (at /usr/libexec/valgrind/vgpreload_memcheck-amd64-linux.so)
      CRYPTO_zalloc (at /usr/lib/x86_64-linux-gnu/libcrypto.so.3)
      BN_new (at /usr/lib/x86_64-linux-gnu/libcrypto.so.3)
      BN_bin2bn (at /usr/lib/x86_64-linux-gnu/libcrypto.so.3)
      <unknown stack frame>
     *asn1integer_to_num (ossl_asn1.c:136)
     *asn1integer_to_num_i (ossl_asn1.c:165)
      rb_protect (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
     *decode_int (ossl_asn1.c:356)
     *int_ossl_asn1_decode0_prim (ossl_asn1.c:777)
     *ossl_asn1_decode0 (ossl_asn1.c:936)
     *ossl_asn1_decode_all (ossl_asn1.c:1058)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      rb_catch_obj (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      rb_catch_obj (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_vm_invoke_proc (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_proc_call_kw (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
    ```

    https://github.com/ruby/openssl/commit/309c55d755

commit e30b5a06dc0a43c35ca9545c661784dcdb5c6806
  Author:     Jeff Zhang <jeff.j.zhang@shopify.com>
  AuthorDate: 2026-03-04 01:19:28 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-03-04 01:19:28 +0900

    ZJIT: Add diff tool for running benchmarks between git refs (#16160)

    For https://github.com/Shopify/ruby/issues/822

    Adds a small script for automatically running benchmarks between two git refs.

    Example output (doubled an increment to `inline_cfunc_optimized_send_count` to illustrate stat diffs):
    ```
    $ ./zjit_diff --before master
    I, [2026-03-03T10:24:52.691660 #48554]  INFO -- : Existing worktree found at /var/folders/l_/p20zlp5j3wx76vr9ggzgzcmr0000gn/T/ruby-zjit-before
    HEAD is now at 7a3940e8b6 Unify rb_node_list_new and rb_node_list_new2
    I, [2026-03-03T10:24:52.729815 #48554]  INFO -- : Found existing build for master, skipping build
    I, [2026-03-03T10:24:52.729881 #48554]  INFO -- : Existing worktree found at /var/folders/l_/p20zlp5j3wx76vr9ggzgzcmr0000gn/T/ruby-zjit-after
    HEAD is now at 3859f12966 dup
    I, [2026-03-03T10:24:52.801287 #48554]  INFO -- : Found existing build for HEAD, skipping build
    I, [2026-03-03T10:24:52.801354 #48554]  INFO -- : Running benchmarks
    I, [2026-03-03T10:24:52.801404 #48554]  INFO -- : ruby-bench already cloned, pulling from upstream

    <... benchmark run logs ...>

    before: ruby 4.1.0dev (2026-03-03T14:05:00Z master 7a3940e8b6) +ZJIT dev +PRISM [arm64-darwin25]
    last_commit=Unify rb_node_list_new and rb_node_list_new2
    after: ruby 4.1.0dev (2026-03-03T15:17:20Z :detached: 3859f12966) +ZJIT dev +PRISM [arm64-darwin25]

    ----------  -------------  -------------  -------------  ------------
    bench         before (ms)     after (ms)  after 1st itr  before/after
    lobsters     747.9 ± 2.9%   757.7 ± 2.4%          0.983   0.987
    railsbench  1183.4 ± 1.9%  1214.5 ± 2.4%          1.001   0.974 (*)
    ----------  -------------  -------------  -------------  ------------

    Legend:
    - after 1st itr: ratio of before/after time for the first benchmarking iteration.
    - before/after: ratio of before/after time. Higher is better for after. Above 1 represents a speedup.
    - ***: p < 0.001, **: p < 0.01, *: p < 0.05 (Welch's t-test)

    Output:
    data/zjit_diff.json
    ================================================================================
    ZJIT Stats Comparison
    ================================================================================

      before (baseline):
        ruby 4.1.0dev (2026-03-03T14:05:00Z master 7a3940e8b6) +ZJIT dev +PRISM [arm64-darwin25]
    last_commit=Unify rb_node_list_new and rb_node_list_new2
      after:
        ruby 4.1.0dev (2026-03-03T15:17:20Z :detached: 3859f12966) +ZJIT dev +PRISM [arm64-darwin25]

    BENCHMARK TIMINGS (lower is better)
    --------------------------------------------------------------------------------
      lobsters:
        before               avg:   0.748s  min:   0.706s  ★ (baseline)
        after                avg:   0.758s  min:   0.735s       +1.3% (slower)
      railsbench:
        before               avg:   1.183s  min:   1.158s  ★ (baseline)
        after                avg:   1.214s  min:   1.182s       +2.6% (slower)

    MEMORY USAGE
    --------------------------------------------------------------------------------
      lobsters:
        before               maxrss:    548.3MB  zjit_mem:     68.6MB
        after                maxrss:    520.8MB  zjit_mem:     68.3MB
      railsbench:
        before               maxrss:    208.3MB  zjit_mem:     29.3MB
        after                maxrss:    205.7MB  zjit_mem:     29.3MB

    SEND COUNTERS (showing differences > 5.0%)
    --------------------------------------------------------------------------------
      lobsters:
        inline_cfunc_optimized_send_count      64,066,387 ( 37.3%) →    105,498,619 ( 61.4%) ▲  +64.7%
        optimized_send_count                  136,557,743 ( 79.5%) →    177,989,922 (103.6%) ▲  +30.3%
        send_count                            171,791,578 (100.0%) →    213,223,697 (124.1%) ▲  +24.1%
      railsbench:
        inline_cfunc_optimized_send_count     130,638,873 ( 36.3%) →    225,643,322 ( 62.8%) ▲  +72.7%
        optimized_send_count                  306,690,230 ( 85.3%) →    401,694,689 (111.8%) ▲  +31.0%
        send_count                            359,393,477 (100.0%) →    454,397,936 (126.4%) ▲  +26.4%

    SUMMARY COUNTERS (showing differences > 5.0%)
    --------------------------------------------------------------------------------
      railsbench:
        invalidation_time                             7ms →            7ms ▲   +5.3%

    COMPILE HIR PASS TIMINGS (showing differences > 5.0%)
    --------------------------------------------------------------------------------
      lobsters:
        eliminate_dead_code_time                    245ms →          232ms ▼   -5.3%
    ```

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 7a3940e8b60a3f0b62db05210947ab841a029ca3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-03 21:25:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-03 23:05:00 +0900

    Unify rb_node_list_new and rb_node_list_new2

    The former is the specialized case of the latter.

commit c128106e60f1a65243b3782a0f14a7a644b7ba6f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-03 21:24:12 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-03 23:05:00 +0900

    Adjust variable type for rb_block_given_p()

commit 8c7f4db893af4c9e40eab5810dc58737dc9010bb
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-03-03 22:16:42 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 22:40:10 +0900

    [ruby/prism] Fix modifier rescue pattern matching

    [Bug #21713]

    https://github.com/ruby/prism/commit/02c944c055

commit a2db2d429f14514c67fcf0523891cd9062dd6a5b
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-15 19:51:29 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-03-03 20:48:43 +0900

    [Feature #21781] Add `ENV.fetch_values`

    Specs/Implementation inspired by methods on hash/env that already exist.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16177

commit 1008a469499bbbefb31f59a1b2cbb6ce0120bbfa
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-18 14:21:45 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 15:04:08 +0900

    [ruby/rubygems] Show release date with bundle outdated

    https://github.com/ruby/rubygems/commit/300cc0c223

commit 8d64eb685401c794a45e489096e0b153a8d62b88
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-13 13:13:27 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 12:29:20 +0900

    [ruby/stringio] Allow read-only methods to work with frozen StringIO

    Fix https://github.com/ruby/stringio/pull/120

    https://github.com/ruby/stringio/commit/b0e3ce88b3

commit 571ce8d77968edcae4d908353f68b6d66d483131
  Author:     Charles Oliver Nutter <headius@headius.com>
  AuthorDate: 2025-02-21 01:55:09 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 12:29:20 +0900

    [ruby/stringio] Add tests for read-only methods on frozen StringIO

    See #120

    https://github.com/ruby/stringio/commit/8cba5aac0a

commit 993c7a272af960d31a3c776129ac4edff6b0b9cd
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-03-03 06:58:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-03-03 06:58:32 +0900

    ZJIT: Don't use find() in clean_cfg (#16284)

    We don't need to materialize an instruction or even look at its
    operands.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 2ccb44c1ba52f5ffbf0e35b218c512b0011281a2
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-03-03 06:35:15 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-03-03 06:35:15 +0900

    ZJIT: Don't use find() in infer_types (#16283)

    No need to materialize the whole instruction; if/when we need the
    operands, do the union-find lookup per operand. This saves on allocation
    time.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit a81c3eb795b93631bac997731590e68c3fd399c2
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-03-03 06:06:03 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-03-03 06:06:03 +0900

    ZJIT: Use LoadField for TypedData ivars (#16259)

    Drops C calls to `rb_ivar_get_at_no_ractor_check` out of the stats completely.

    Co-authored-by: Alan Wu <XrXr@users.noreply.github.com>

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 3b6562f663c14d848f8c4f752b5557b8e85d5910
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-03-03 05:24:46 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 05:41:55 +0900

    [ruby/prism] Fix up endless method definition with do/end

    [Bug #21714]

    https://github.com/ruby/prism/commit/0f47e18335

commit 2b8c10075e21be9bcc33030a399e7c4bdf286c21
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-03-03 04:10:45 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 04:48:18 +0900

    [ruby/prism] Prism::ParseResult#continuable?

    An API to determine if more input could fix the existing syntax errors.

    https://github.com/ruby/prism/commit/6701ffe0f5

commit 2106ecec1d5b257b1b92a0a66dc3f5e392f68ffe
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-03-03 02:43:30 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 02:54:26 +0900

    [ruby/prism] Require arguments to Source.for

    https://github.com/ruby/prism/commit/b38010c420

commit 726205b354d1068147719fb42e1de743f1838ef1
  Author:     ZHIJIE XIE <40601688+dummyx@users.noreply.github.com>
  AuthorDate: 2026-03-03 02:40:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-03-03 02:40:57 +0900

    string.c: guard tmp in rb_str_format_m (GH-16280)

    Keep tmp alive while RARRAY_CONST_PTR(tmp) is used by rb_str_format.

    [alan: sunk the guard below usage]
    Reviewed-by: Alan Wu <XrXr@users.noreply.github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16280

    Merged-By: XrXr

commit 460566ab854e79ed43afdd0c01b14cbd7501fee6
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-03-03 02:25:27 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 02:35:03 +0900

    [ruby/prism] Reject infix operators on command call on writes

    https://github.com/ruby/prism/commit/4e71dbfc7b

commit c7ed328cd569a258aa949f78f721195e2be15e9e
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-03-03 01:49:29 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-03 02:07:05 +0900

    [ruby/prism] Fix in handling

    in is a unique keyword because it can be the start of a clause or
    an infix keyword. We need to be explicitly sure that even though in
    _could_ close an expression context (the body of another in clause)
    that we are not also parsing an inline in. The exception is the
    case of a command call, which can never be the LHS of an expression,
    and so we must immediately exit.

    [Bug #21925]
    [Bug #21674]

    https://github.com/ruby/prism/commit/20374ced51

commit 6a31ffa3d492852fd8f409e3ae1e86f2891cc104
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-28 11:42:48 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-03-03 01:05:16 +0900

    ZJIT: Move is_meta_class() from hir::Function to VALUE

    `self` was unused.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16272

commit 740bbddd2ff9b78f5eb3062cdbfcbd397d989f68
  Author:     ydah <t.yudai92@gmail.com>
  AuthorDate: 2026-03-01 21:46:40 +0900
  Commit:     yui-knk <spiketeika@gmail.com>
  CommitDate: 2026-03-02 15:37:38 +0900

    Lrama v0.8.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16276

commit b0ee787733f2a497b5b8d4a14118cfe0c684e349
  Author:     Taketo Takashima <t.taketo1113@gmail.com>
  AuthorDate: 2026-03-02 13:38:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-03-02 15:20:44 +0900

    [ruby/rubygems] Restrict GitHub Actions workflow permissions for newgem

    - Configure minimal required permissions in the GitHub Actions workflow template
    - Bump actions/checkout from 4 to 6
    - Bump actions/upload-artifact from 3 to 7

    https://github.com/ruby/rubygems/commit/e4c82bd095

commit b92f1d1097039dc5b4216994d4eb6c9c3e47d345
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-03-02 14:15:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-03-02 15:19:20 +0900

    Use .bundle only if all deps present

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16279

commit 4fc55d888b15ae2875e8458200882e3bad701cc5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-03-02 12:52:37 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-03-02 15:19:20 +0900

    Use .bundle gem paths for test deps with ruby/ruby repository.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16279

commit d68e4be1873e364c5ee24ed112bce4bc86e3a406
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-01 19:38:14 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-01 19:44:59 +0900

    lrama pre-0.8.0

    master as of 2026-03-01.
    ruby/lrama@e8dbb063afd42432899dac796384b00ef61986b0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16275

commit 45dce19e22de7341d399c09599f3449fa3750a34
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-01 12:19:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-01 19:44:59 +0900

    parse.y: Parameterize argument list rules

    Parametrize `block_param` and `f_args` into `arg-list` and
    `tail-only-args`.  Since the pattern for `pre_args` alone differs
    between `opt_comma` and `excessed_comma`, retain it within each rule.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16275

commit 0980de4c1a3dd9939fbf4abcf812a9e2695e3786
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-01 12:09:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-01 12:10:06 +0900

    parse.y: Extract new_empty_args_tail macro

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16275

commit 504cf455fb17642a5ddb206fc14d01a7a4b0566f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-03-01 10:30:31 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-01 12:04:38 +0900

    parse.y: Extract f_empty_arg

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16275

commit 851a10bcb582211ac47101f0d1baf0a109e74200
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-28 21:52:47 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-03-01 09:20:18 +0900

    Revert "parse.y: narrow excessed_comma to block_param_def"

    This reverts commit 2239d54348d9f1f7768860efc9e76876f85766d8.
    At first glance, it seemed like a good idea, but it wasn't all that
    great.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16275

commit 19b636d3ecc8a824437e0d6abd7fe0c24b594ce0
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-03-01 00:24:13 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-03-01 03:59:07 +0900

    Remove unused variable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16274

commit 85b04616269660e2d06441e2a833edad4491564d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 17:12:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Revert and ignore template-injection error at capi extension workflow

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit b8d714849a947dcf0fe06cb70fd578e9bdc8c8a8
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 16:25:43 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Fix: Use shell syntax for SETARCH command

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit eae6d265d531e4dd6259c762f1eeda3bde89f6c4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 16:17:51 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Use zizmorcore/zizmor-action

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit 520b0898135f7a74f72d8b0fb58c40e323b0b631
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 15:58:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Rename CodeQL workflow to Check SAST tool

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit 4b9af00c9cf9a809a72c12a43a9b0317e4eb490c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 15:25:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Refactor GitHub Actions to use environment variables

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit 64d63ba0606762140fa8db5c6614026055377c0a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 15:16:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Fix: Set persist-credentials to false for actions/checkout

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit f47c57d3a1400fb9272e721235ac33414066e23c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 15:03:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Add zizmor ignore directives for github-env

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit 41c11dc31d0b2514291e7dba432e945a5d73b880
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 14:43:28 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Expose inputs as env vars in composite actions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit aef8fd05705462d2c91eb32b11a28c2af4b933a3
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 13:16:04 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Add Zizmor baseline ignore configuration

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit 0b342d29c30564180d3c1d3246edd03f10703cfd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 12:35:11 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 20:26:16 +0900

    Add Zizmor job to workflow

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16273

commit 373eacb8416f8b20e89e2b52dc007c5958a79bdb
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 11:21:50 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-28 13:02:35 +0900

    [ruby/rubygems] Skip Windows group warning for realworld specs

    https://github.com/ruby/rubygems/commit/98a355dcfb

commit 3251792f491bd6f8bff71c6fd3352f66ac635902
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-28 05:23:42 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-02-28 11:29:19 +0900

    ZJIT: Fix infinite loop from `make_equal_to(x,y)` where `x=y`

    Sometimes it's convenient to write that
    `make_equal_to(x, big_decision_tree_to_find_replacement)` where
    most of the time the decision tree gives something not equal to `x`.

    Since infinite loops are hard to debug and this condition is easy to
    check, let's allow it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16271

commit 4eadf035d0de44b940260ca1557969ed1926f36b
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-21 06:16:48 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-02-28 11:29:19 +0900

    ZJIT: Check special_const_p() before using rb_obj_shape_id()

    It only works with heap objects.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16271

commit 55f2a8d1bbed98e913f18beaa7791fbfbf0b588c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 10:50:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 11:21:27 +0900

    Bump up to latest GitHub Actions versions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16270

commit 903b709c61f05af6116150d3d5f5b12fb36ba588
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-28 10:48:05 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 11:21:27 +0900

    Pin GitHub Actions to specific SHAs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16270

commit 8fb5df26103396819a5b2ac6145d31b1599632bc
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2026-02-26 22:26:42 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-28 08:15:58 +0900

    win32/configure.bat accept empty prefix

    Currently, running `win32/configure.bat --prefix=` outputs `prefix = \=/` in the Makefile.
    Fix this to prevent invalid values from being output.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16255

commit 3341022648623706cddbc607d08753d2b37b458b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-27 17:59:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Add setup-ruby step for tool scripts

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit a5af2adab17e0f54a094872afd46ce8fa6f6563d
  Author:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  AuthorDate: 2026-02-27 10:19:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Fix a typo in bundled_gems.yml

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit b4367db8878ab5a6374ad3c01b2bbd6d06e19db9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-26 18:44:03 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Run GitHub releases updater in workflow

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit e43b35f2f1e394a901bf00e0116b1e182d8246b1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-26 18:43:32 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Detect previous Ruby version in update script

    Read include/ruby/version.h to compute the previous Ruby version and
    use it as the default FROM argument in
    tool/update-NEWS-github-release.rb.

    Add a workflow step to run the script for Ruby 4.0 in bundled_gems.yml
    Detect previous Ruby version in update script

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit 9b0a3db0689bb55f443796366d4bfcc41830be2b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-26 18:38:36 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Preserve gem sub-bullets in NEWS.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit 7c7533514891cc3933d2b4753cb7d647ad19979c
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-26 18:24:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Run `ruby tool/update-NEWS-github-release.rb 4.0 --update`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit 4ab238341327b95b539000f10930f62d27f0dedc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-26 18:21:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Add update mode and NEWS.md parsing

    Read NEWS.md locally when "news" is requested, parse stdlib updates,
    collect GitHub release ranges per gem, and optionally update NEWS.md
    in-place with sub-bullets and footnote links when --update is passed

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit aec4b44d1e339044d917f233be7025eea5aa672d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-26 17:58:18 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-28 05:23:16 +0900

    Add tool to update NEWS from GitHub releases

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16254

commit c57d594f73576c9e316972e83a2fcc4df730882e
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-28 05:00:29 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-28 05:00:29 +0900

    ZJIT: Use LoadField for Class/Module ivars (#16252)

    Assume only one box (root box) and invalidate otherwise. Drops C calls to `rb_ivar_get_at_no_ractor_check`.

    Before:
    ```
    Top-20 calls to C functions from JIT code (77.3% of total 64,311,573):
                                 rb_vm_opt_send_without_block: 11,939,854 (18.6%)
                                                 rb_hash_aref:  5,400,091 ( 8.4%)
                                            rb_vm_invokeblock:  4,453,357 ( 6.9%)
                         rb_zjit_writebarrier_check_immediate:  4,279,890 ( 6.7%)
                                    rb_vm_getinstancevariable:  3,504,908 ( 5.4%)
                                                   rb_vm_send:  3,103,424 ( 4.8%)
                               rb_ivar_get_at_no_ractor_check:  2,864,766 ( 4.5%)
                                            rb_obj_is_kind_of:  2,313,479 ( 3.6%)
                                                 rb_hash_aset:  1,903,359 ( 3.0%)
                                                   Hash#fetch:  1,639,937 ( 2.5%)
                                    rb_vm_setinstancevariable:  1,596,791 ( 2.5%)
                                   rb_vm_opt_getconstant_path:  1,328,761 ( 2.1%)
                                              rb_jit_ary_push:    960,563 ( 1.5%)
                                    rb_ec_ary_new_from_values:    722,913 ( 1.1%)
                                   rb_class_allocate_instance:    721,483 ( 1.1%)
                                                        fetch:    713,134 ( 1.1%)
                                            rb_str_buf_append:    667,545 ( 1.0%)
                                                  rb_ivar_get:    585,817 ( 0.9%)
                                        rb_hash_new_with_size:    520,347 ( 0.8%)
                                            rb_vm_sendforward:    479,029 ( 0.7%)
    ```

    After:
    ```
    Top-20 calls to C functions from JIT code (76.5% of total 62,282,359):
                                 rb_vm_opt_send_without_block: 11,939,850 (19.2%)
                                                 rb_hash_aref:  5,400,092 ( 8.7%)
                                            rb_vm_invokeblock:  4,453,357 ( 7.2%)
                         rb_zjit_writebarrier_check_immediate:  4,279,893 ( 6.9%)
                                    rb_vm_getinstancevariable:  3,504,920 ( 5.6%)
                                                   rb_vm_send:  3,103,441 ( 5.0%)
                                            rb_obj_is_kind_of:  2,313,510 ( 3.7%)
                                                 rb_hash_aset:  1,903,359 ( 3.1%)
                                                   Hash#fetch:  1,639,937 ( 2.6%)
                                    rb_vm_setinstancevariable:  1,596,797 ( 2.6%)
                                   rb_vm_opt_getconstant_path:  1,328,761 ( 2.1%)
                                              rb_jit_ary_push:    960,563 ( 1.5%)
                               rb_ivar_get_at_no_ractor_check:    835,498 ( 1.3%)
                                    rb_ec_ary_new_from_values:    722,921 ( 1.2%)
                                   rb_class_allocate_instance:    721,492 ( 1.2%)
                                                        fetch:    713,135 ( 1.1%)
                                            rb_str_buf_append:    667,545 ( 1.1%)
                                                  rb_ivar_get:    585,815 ( 0.9%)
                                        rb_hash_new_with_size:    520,348 ( 0.8%)
                                            rb_vm_sendforward:    479,029 ( 0.8%)
    ```

    The remaining `rb_ivar_get_at_no_ractor_check` are due to TypedData access, mostly on `Thread`.

commit 50f51f75c607e74906b88e695dd5577f5690b5bd
  Author:     Tomás Coêlho <36938811+tomascco@users.noreply.github.com>
  AuthorDate: 2026-02-28 03:13:47 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-28 03:13:47 +0900

    ZJIT: constant fold bitwise OR (|) operations (#16235)

    Continuation of https://github.com/ruby/ruby/pull/16226.

    ### Considerations
    - The OR (`|`) operation in Rust has the same behavior as in Ruby (it compiles to a assembly `or` instruction: https://godbolt.org/z/5McGzj783);
    - There are no risk of overflows;
    - In the test, I added the result of the interpreter in an assertion based on feedback of my last PR.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit eafbf6e5b93596193870cb5eae8d2ed1da7ded0c
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-28 02:14:11 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-28 03:04:06 +0900

    ZJIT: Fix IsA effect

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16269

commit 44fe95ead403080e90a679f20cdf0d600bb68d95
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-28 02:11:46 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-28 03:04:06 +0900

    ZJIT: Fix HasType effect

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16269

commit d5cca099afba2f3cfdbb5d45e79556faeb343567
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-28 02:10:06 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-28 03:04:06 +0900

    ZJIT: Fix GetEP effect

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16269

commit 1e1d8332e7c43193ad05dff13ba4fe1bf7304b8f
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-28 02:07:04 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-28 03:04:06 +0900

    ZJIT: Remove GetLEP

    Use get_lvar_level and GetEP instead.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16269

commit 5d87dd6d3682d9b728b2b28a8a44ce2dc26e0c1e
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-28 02:43:59 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-28 02:43:59 +0900

    ZJIT: Handle splatkw YARV instruction (#16267)

    The most common cases are nil and hash, so just cover those. If we need to convert to a hash, we can handle that later.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 68080febee3279d52107a84a1e1903933297292e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-28 00:32:21 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-28 01:01:46 +0900

    parse.y: Unify to use only tagged references

    Unify references in rules that mix positional references and tagged
    references.  Leave the positional reference-only rules unchanged.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16268

commit f3323b048f47d0da706cec8f7e17444fe9421165
  Author:     Nozomi Hijikata <121233810+nozomemein@users.noreply.github.com>
  AuthorDate: 2026-02-28 00:33:02 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-28 00:33:02 +0900

    ZJIT: Replace Getlocal with LoadSP or GetEP+LoadField (#16242)

    Since `GetLocal` (for `level > 0`) is now split into `GetEP` + `LoadField`(https://github.com/ruby/ruby/pull/16215),
     we can remove the Insn and use `LoadSP` instead for the consistency.
    Also removed a counter that appeared unnecessary.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 486f7fcc27b2ef08c18da9666f36e2f9583efd96
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-27 23:09:31 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-27 23:47:11 +0900

    parse.y: prefer @$ over @0 in empty-rule actions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16266

commit 2ecda70f8730a60661f69f06a44158778e2051a0
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-27 10:08:54 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-02-27 23:14:59 +0900

    ZJIT: GuardType and GuardTypeNot can read from memory

    When guarding on anything but special const forms (`types::Immediate`),
    we need to dereference the VALUE to load RBasic::flags and maybe
    RBasic::class. Those are memory read effects.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16261

commit 6af0de237935f162ee3089b314f0c33911d442da
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-27 19:51:22 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-27 22:33:36 +0900

    [ruby/prism] Fix error message for block/lambda with `...` argument

    They currently complain that the parent method is not forwarding.
    But the actual problem is that these types of arguments simply don't
    accept `...`

    Fixes [Bug #21927]

    https://github.com/ruby/prism/commit/0aa2363331

commit 2239d54348d9f1f7768860efc9e76876f85766d8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-26 23:29:53 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-27 13:10:04 +0900

    parse.y: narrow excessed_comma to block_param_def

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16264

commit cded315c516c48d4b4c10d37ce13ea46858cd6c8
  Author:     Samuel Williams <samuel.williams@shopify.com>
  AuthorDate: 2026-02-27 11:56:33 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-27 11:57:01 +0900

    [ruby/zlib] Avoid retrying on interrupt if there is no further work
    to be done.
    (https://github.com/ruby/zlib/pull/121)

    https://github.com/ruby/zlib/commit/c975060f02

commit e276076a2f3aaae3c462c1a0fc98c285ba8a2a28
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-27 10:49:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-27 10:49:57 +0900

    The `case` expression is preferable to the pseudo-condition operator

commit 9ed1517cb97e8278f64a4a665864a230b0cd52d0
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-27 04:41:12 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-27 08:18:06 +0900

    ZJIT: Check if args are compatible before emitting assumptions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16257

commit 88d046e106ceff5fa86c3a6d327d4d427a2a1db4
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-27 04:25:34 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-27 08:18:06 +0900

    ZJIT: Add HIR tests for hash as positional arg to keyword-only method

    Follow-up to GH-16223 to also cover this at the HIR level.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16257

commit ac57159ca63b6e6ad24a2d44cb4eb3c1e537e4c7
  Author:     Kevin Menard <kevin@nirvdrum.com>
  AuthorDate: 2026-02-27 07:55:59 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-27 07:55:59 +0900

    ZJIT: Don't attempt to disassemble code when there's a compilation error (GH-16251)

    After a compilation error, the write pointer may point into unmapped JIT memory. Passing that address as the end of the disassembly range to capstone causes a segfault when it reads past the boundary of the mapped region.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16251

    Merged-By: XrXr

commit 7b3207ecf1a19f645caee35944bd56a8e5b68c85
  Author:     Alexander Momchilov <alexander.momchilov@shopify.com>
  AuthorDate: 2026-02-27 04:43:07 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-27 05:16:23 +0900

    Use new `case()` expressions in GitHub workflows

    https://docs.github.com/en/actions/reference/workflows-and-actions/expressions#case

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16258

commit b4aa7462be9913d1d3739bf56a0a71a763a5d4a3
  Author:     ReLU <82130499+ykawabata17@users.noreply.github.com>
  AuthorDate: 2026-02-27 01:43:37 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-27 01:43:37 +0900

    ZJIT: Fix ArgumentError for hash as positional arg to keyword-only method (GH-16223)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16223

    Merged-By: XrXr

commit 4455fdc201981122c67e9913d972b3cbd7b93e47
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-25 13:38:36 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-27 01:26:57 +0900

    Mark callcache as !needs_cleanup_p

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16243

commit 8eab3172788ac1f2760d7df46e07e5b0ae7e7ea6
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-25 09:30:43 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-27 01:26:57 +0900

    Convert cc_refinement_table into TypedData object

    This converts the cc_refinement_table in the VM into a standard
    TypedData object using rb_gc_declare_weak_references to allow it to be
    .

    This allows us to store all the refinements in a flat array, and simply
    remove them as that are GC'd, we don't need a set for efficient deletes.

    This should also allow us to assume that imemo_callcache never requires
    additional cleanup.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16243

commit 64fdfb722bcc36ffb6a41b024707a77b8cedc84e
  Author:     ndossche <nora.dossche@ugent.be>
  AuthorDate: 2026-02-24 23:43:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-26 21:10:49 +0900

    [ruby/openssl] Fix memory leak if sk_push fails

    If it fails, then the duplicated item is not freed.
    Solve it by making sure the push cannot fail by reserving the necessary
    stack size upfront.

    Example Valgrind trace:
    ```
    14,009 (384 direct, 13,625 indirect) bytes in 1 blocks are definitely lost in loss record 27,287 of 27,373
      malloc (at /usr/libexec/valgrind/vgpreload_memcheck-amd64-linux.so)
      CRYPTO_zalloc (at /usr/lib/x86_64-linux-gnu/libcrypto.so.3)
      <unknown stack frame>
      ASN1_item_new (at /usr/lib/x86_64-linux-gnu/libcrypto.so.3)
     *ossl_x509_alloc (ossl_x509cert.c:97)
      <unknown stack frame>
      rb_class_new_instance_pass_kw (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      rb_catch_obj (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      rb_catch_obj (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
    ```

    https://github.com/ruby/openssl/commit/b53628b127

commit 3a7f3cf37139fc54305a0d413fee45d68519a5a0
  Author:     ndossche <7771979+ndossche@users.noreply.github.com>
  AuthorDate: 2026-02-26 04:15:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-26 20:35:50 +0900

    [ruby/openssl] Fix missing error check on BIO_get_mem_ptr()

    LibreSSL docs state this can fail. OpenSSL has no docs for this, but the
    implementation goes via BIO_ctrl() which can fail (e.g. via a callback).
    Example Valgrind trace:
    ```
    Invalid read of size 1
      memmove (at /usr/libexec/valgrind/vgpreload_memcheck-amd64-linux.so)
      memcpy (string_fortified.h:29)
      ossl_str_new (ossl.c:107)
      ossl_membio2str (ossl_bio.c:36)
      ossl_x509ext_get_value (ossl_x509ext.c:390)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      rb_catch_obj (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_yield (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_ary_each (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      rb_catch_obj (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      rb_vm_exec (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_vm_invoke_proc (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      rb_proc_call_kw (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      <unknown stack frame>
      <unknown stack frame>
      ruby_run_node (at /usr/lib/x86_64-linux-gnu/libruby-3.2.so.3.2.3)
      <unknown stack frame>
      (below main) (libc_start_call_main.h:58)
    ```

    https://github.com/ruby/openssl/commit/4fb09446d6

commit 319de3c513ba6a33c97c4af4c2a03f0d58d7aa10
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-26 20:32:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-26 20:32:00 +0900

    git must run in the source tree instead of the build directory

commit 9ab1dfadc9ec2b435875b4d2ec98479f7defb690
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2026-02-26 06:44:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-26 06:44:16 +0900

    ZJIT: Decouple gen_function_stub and gen_function_stub_hit_trampoline (#16249)

    Before this change, gen_function_stub and
    gen_function_stub_hit_trampoline communicated via a scratch register.
    We would like gen_function_stub_hit_trampoline to have more freedom with
    regard to the registers it uses, especially for the CCall in to
    function_stub_hit.  Instead of communicating via scratch register, we'll
    communicate via stack.

    Practically speaking, this means:

    * Stop using x15 (scratch reg) to communicate iseq call addr from call
      stub to function sub hit trampoline; use stack instead
    * Don't try to CCall with x15 as first argument; can't use scratch reg
      in parallel move of arguments

    Here is pseudo assembly of before this commit:

    ```
    some_send_direct_in_a_ruby_method(JIT code):
      mov x15, gen_function_stub
      mov x0, self
      mov x1, 1
      blr x15

    gen_function_stub:
      mov x15, 0xISEQADDR (the address of the ISEQ we _want_ to compile)
      jmp function_stub_hit_trampoline

    function_stub_hit_trampoline:
      function prologue
      cpush ALL_JIT_REGS
      mov x0, x15 # currently x15 is 0xISEQADDR
      mov x1, CFP
      mov x2, SP
      blr function_stub_hit
      mov x15, x0 # write jump address to x15 (code pointer for compiled iseq)
      cpop ALL_JIT_REGS
      function epilogue
      jmp x15
    ```

    Here is pseudo assembly of after this commit:

    ```
    some_send_direct_in_a_ruby_method(JIT code):
      mov x15, gen_function_stub
      mov x0, self
      mov x1, 1
      blr x15

    gen_function_stub:
      mov x15, 0xISEQADDR (the address of the ISEQ we _want_ to compile)
      push x15
      jmp function_stub_hit_trampoline

    function_stub_hit_trampoline:
      pop x15 # get the ISEQ addr from gen_function_stub
      function prologue
      cpush ALL_JIT_REGS
      mov x0, x15 # currently x15 is 0xISEQADDR
      mov x1, CFP
      mov x2, SP
      blr function_stub_hit
      mov x15, x0 # write jump address to x15 (code pointer for compiled iseq)
      cpop ALL_JIT_REGS
      function epilogue
      jmp x15
    ```

  Notes:
    Merged-By: tenderlove <aaron.patterson@gmail.com>

commit b3a1286d5c921da8ee9a1cee05b3d4c3d588efee
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-25 04:58:47 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-26 06:19:57 +0900

    Avoid duplicate struct name in rb_raw_obj_info

    Previously we printed the struct name of T_DATA both in
    rb_raw_obj_info_buitin_type and in rb_raw_obj_info_common via type_name.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16241

commit ad380f8752c93e4c763329825ebf271e583b2b3c
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-25 19:58:02 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-26 05:58:20 +0900

    Correct timezone type: It's Asia/Tokyo, not Tokyo/Asia

    https://timezonedb.com/time-zones/Asia/Tokyo

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16244

commit 2168fdbdd4f869008aaafea4b7a83a012eee4184
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-26 01:23:02 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-26 05:57:52 +0900

    Move class pre-aging out of the allocation path

    Previously classes and modules were pre-aged. Ie. as soon as they're
    allocated they are aged to old_age - 1. This was done with the
    assumption that classes are generally always long lived, so we should
    assume that any that survive a single GC can be considered old.

    This commit keeps the same semantics, but moves the logic out of the
    allocation path, in order to simplify allocation. Classes and modules
    are now set to old-age the first time they are marked.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16247

commit b52cb82d3c7b2aacdc7b8a452ffe74dbef54db26
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-26 02:08:36 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-26 02:08:36 +0900

    ZJIT: Format negative offsets as small negative hex values (#16248)

    Before:

        Optimized HIR:
        fn block in <main>@benchmarks/setivar.rb:40:
        bb1():
          EntryPoint interpreter
          v1:BasicObject = LoadSelf
          Jump bb3(v1)
        bb2():
          EntryPoint JIT(0)
          v4:BasicObject = LoadArg :self@0
          Jump bb3(v4)
        bb3(v6:BasicObject):
          v10:CPtr = GetEP 1
          v11:BasicObject = LoadField v10, :obj@0xffffffffffffffe8    <=
          PatchPoint NoSingletonClass(TheClass@0x1037633c0)
          PatchPoint MethodRedefined(TheClass@0x1037633c0, set_value_loop@0xf5f1, cme:0x103a14650)
          v21:HeapObject[class_exact:TheClass] = GuardType v11, HeapObject[class_exact:TheClass]
          v22:BasicObject = SendDirect v21, 0x16cf41630, :set_value_loop (0x16cf41670)
          CheckInterrupts
          Return v22

    After:

        Optimized HIR:
        fn block in <main>@benchmarks/setivar.rb:40:
        bb1():
          EntryPoint interpreter
          v1:BasicObject = LoadSelf
          Jump bb3(v1)
        bb2():
          EntryPoint JIT(0)
          v4:BasicObject = LoadArg :self@0
          Jump bb3(v4)
        bb3(v6:BasicObject):
          v10:CPtr = GetEP 1
          v11:BasicObject = LoadField v10, :obj@-0x18    <=
          PatchPoint NoSingletonClass(TheClass@0x102bc3420)
          PatchPoint MethodRedefined(TheClass@0x102bc3420, set_value_loop@0xf5f1, cme:0x102e945f0)
          v21:HeapObject[class_exact:TheClass] = GuardType v11, HeapObject[class_exact:TheClass]
          v22:BasicObject = SendDirect v21, 0x16dadd630, :set_value_loop (0x16dadd670)
          CheckInterrupts
          Return v22

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 027131973fe4e7fc11f87f930f5c2a4719d9d66d
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-02-23 06:40:04 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-25 22:38:45 +0900

    [ruby/prism] Generate RBI from RBS

    https://github.com/ruby/prism/commit/2c88ed893f

commit bc1d75adced050f01248a96ba90ded345ffc08db
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-19 02:05:31 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-25 22:38:45 +0900

    [ruby/prism] Don't document rbs inline magic comment

    https://github.com/ruby/prism/commit/e371985c91

commit fb39d5898f8b4ea0d7a4cea596d91cdf0dc81d8b
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-02-18 00:27:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-25 22:38:44 +0900

    [ruby/prism] rbs-inline

    https://github.com/ruby/prism/commit/1fdd4c5a49

commit 9aa3dc6f82c6f8885b90f078f9537104ee6a0bc9
  Author:     Scott Myron <samyron@gmail.com>
  AuthorDate: 2026-02-25 12:53:15 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-25 16:24:42 +0900

    [ruby/json] Remove unused load_uint8x16_4 function.

    https://github.com/ruby/json/commit/93bc1b3838

commit da1daba07afccccf89226c5f8b24e83a6b051371
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-25 09:21:14 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-25 09:21:14 +0900

    ZJIT: Refine effects for CheckInterrupts to InterruptFlag|Control (#16240)

    CheckInterrupts only reads ec->interrupt_flag and conditionally
    side-exits — it doesn't touch PatchPoint invariants or the allocator.
    Add an InterruptFlag leaf under Memory in the abstract heap DAG and
    narrow CheckInterrupts from Any to read(InterruptFlag)|write(Control).

    This lets remove_redundant_patch_points see through CheckInterrupts,
    eliminating duplicate PatchPoints that were previously separated by
    an interrupt check.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit c5d85d5ab0c317ecbf2054e98ce203ffdc148e4f
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-22 14:32:51 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-25 08:53:34 +0900

    Improve error message failing to copy proc

    Previously, when passing an unshareable proc to a Ractor we would get
    the message:

        'Ractor.new': allocator undefined for Proc (TypeError)

    With this change we get:

        'Ractor.new': can not copy unshareable object #<Proc:0x00007f1b31713600 test.rb:2> (Ractor::Error)

    Which should hopefully be a little clearer about the problem and make it
    simpler to debug.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16221

commit f1c2fafa0c4394f15927cc9238de970e6970a42d
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-25 07:43:33 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-25 07:43:33 +0900

    ZJIT: Ratchet down Guard* effects (#16236)

    Guards don't write to (e.g. PatchPoint) memory, just change if we
    side-exit into the interpreter or not, so lower their effects.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 7da57563c8dddadba824734c70284d1f221d1f2c
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-25 07:36:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-25 07:36:20 +0900

    ZJIT: Refine effects for IsBitNotEqual and FixnumBitCheck to Empty (#16237)

    Both instructions are pure computations with no side effects:
    IsBitNotEqual is a cmp+csel (identical to IsBitEqual, already Empty),
    and FixnumBitCheck is a test+csel on a tagged Fixnum bit. Neither
    reads memory, writes anything, allocates, or can raise exceptions.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 7e028b861d6faf868d0fcd6002509417bade9e14
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-25 07:35:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-25 07:35:17 +0900

    ZJIT: Pull out GetEP from IsBlockParamModified (#16234)

    We can hopefully de-duplicate this GetEP soon.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 56bdb93b024495bfd544c75a00eaf5d68b15be6c
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-25 06:28:10 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-25 07:01:08 +0900

    Remove man page date check

    This doesn't work because actions/checkout uses a fetch depth of 1, so
    every CI run acts as though man pages were made in the most recent
    commit.

    Additionally the VCS code uses committed date, so this check will fail
    if any PR is made that changes man pages, but then is merged the
    following day JST.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16239

commit 4b4da98832a6eaa4e9e6384325ca2a0040b13961
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-20 16:04:21 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-25 02:39:35 +0900

    Avoid and simplify rb_alloc_tmp_buffer_with_count

    There's no reason to ever call this and the "count" value is ignored.
    Because this is part of the public API I left it as a stub, but it could
    likely be removed.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16210

commit 7a36808d78dc1a1ef3719225eaa59802a933cbf5
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-20 16:03:28 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-25 02:39:35 +0900

    Use rb_alloc_tmp_buffer in new_from_an_RString

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16210

commit c1f70394c94ad3047fbf9cdce8325d7ef0097e90
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-20 15:43:18 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-25 02:39:35 +0900

    Remove rb_imemo_tmpbuf_set_ptr

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16210

commit 3aa89271b7b585f3623ceaad563f98f7d04643da
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-02 02:32:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-24 22:53:26 +0900

    [ruby/prism] Introduce xfree_sized and xrealloc_sized

    This will allow prism to pass buffer sizes to the Ruby GC.

    It also helps avoid buffer overflow as it confirms the size was
    correctly tracked all the way until the buffer is freed.

    https://github.com/ruby/prism/commit/a5c3ee3e4c

commit ebd57856c2a794a7b4c43402deb455cbc36f3c81
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-23 21:53:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-24 22:46:05 +0900

    [ruby/prism] Fix some locations in the the config

    https://github.com/ruby/prism/commit/64e29baac6

commit 682f36ab1fd0468a0eb42946d53809e942ab2141
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2026-02-24 16:08:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-24 16:08:36 +0900

    Update bundled gems list as of 2026-02-24

commit 70c625148892553c4dd50adefda955d45b46ff47
  Author:     NARUSE, Yui <naruse@airemix.jp>
  AuthorDate: 2026-02-24 14:27:52 +0900
  Commit:     NARUSE, Yui <naruse@airemix.jp>
  CommitDate: 2026-02-24 14:27:52 +0900

    Use rev-parse HEAD instead of log --format=%H -1

commit 997ac19b74259b13f777a548b813a0f2c2228554
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-24 12:06:32 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-24 12:06:32 +0900

    ZJIT: Remove redundant PatchPoints within basic blocks (#16231)

    Add a new optimization pass that deduplicates PatchPoint instructions
    asserting the same invariant within a basic block when no intervening
    instruction could invalidate it.

    This is common in practice — e.g., `1 + 2 + 3` produces two identical
    `PatchPoint MethodRedefined(Integer, +, cme)` because each `+` call
    inserts one. The second is redundant since nothing between them can
    redefine Integer#+.

    The approach adds a `PatchPoint` leaf to the abstract heap DAG so the
    effect system can distinguish instructions that could invalidate
    invariants (writes to PatchPoint, e.g. Send/CCall) from those that
    cannot (e.g. IncrCounter, Const). The pass maintains a HashSet of
    seen invariants per block and skips duplicates, clearing the set when
    an instruction writes to the PatchPoint heap.

    Removed PatchPoints' orphaned Snapshot dependencies are cleaned up by
    the subsequent DCE pass.

    I added a new test with snapshots to `zjit/src/hir/tests.rs` in the first commit
    so that you can see how the change affects it in the second commit:
    https://github.com/ruby/ruby/pull/16231/changes/88cf26b6380cdf577522d11b4f3c838fed2a71b3#diff-38be021d8d0035cca77d3eab5ccc530109e7832f4711a5beb4dfced7001787ae

    closes https://github.com/Shopify/ruby/issues/779

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 8e9eb698b6638e0f3e76748c756f699e79d2e97d
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2024-03-14 09:17:20 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2026-02-24 12:01:06 +0900

    Freeze singleton class chain

    The following code:

    ```ruby
    x = Object.new
    sc1 = x.singleton_class
    sc2 = sc1.singleton_class
    x.freeze
    ```

    Would freeze sc1 but not sc2, even though sc1 would be frozen.

    Handle this by walking the class pointer chain for the object.
    If the class is a singleton class, and it isn't frozen, and the
    attached object for the singleton class is the object, the
    singleton class should be frozen, and we move to the next iteration.

    Fixes [Bug #20319]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/10245

commit b479c41dd4fc2a3bd53bba545434eae495aec556
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-24 09:40:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-24 11:12:49 +0900

    Use .bundle gems dependencies directly

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16230

commit f3ee4bd0abe2f72bf804a9f564ab763fd5a59d48
  Author:     Nozomi Hijikata <121233810+nozomemein@users.noreply.github.com>
  AuthorDate: 2026-02-24 08:58:04 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-24 08:58:04 +0900

    ZJIT: Remove redundant snapshot for opt_getconstant_path (#16229)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 070b7d40d35f8dbcf81809c6b19be2bbba1c8bc1
  Author:     Tomás Coêlho <36938811+tomascco@users.noreply.github.com>
  AuthorDate: 2026-02-24 07:03:22 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-24 07:03:22 +0900

    ZJIT: constant fold bitwise AND (&) operations (#16226)

    Following up https://github.com/ruby/ruby/pull/16225, I'm implementing fold on AND (&) operations.

    - Ruby turns this operation into a C `&` in https://github.com/tomascco/ruby/blob/880eb3c76f09c44c85389ac5efbc555afafa3e6f/numeric.c#L5197-L5210
    - Rustc compiler emits an `and` assembly instruction on x86: https://godbolt.org/z/Ee74vKTfb

    So the operations are equivalent. I tested manually some cases and the results match.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 2d8e24c8c4284fa32552107e0ec64280730e9b18
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-24 05:31:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-24 05:31:13 +0900

    ZJIT: Guard receiver type in inline Array method handlers (#16141)

    inline_array_push, inline_array_pop, and inline_array_aref did not
    guard/coerce the receiver to Array type before emitting Array-specific
    HIR instructions (ArrayPush, ArrayPop, ArrayLength, ArrayAref).

    This caused a MismatchedOperandType validation failure when these
    handlers were called from the InvokeSuper CFUNC path, where the
    receiver (self) has type BasicObject rather than Array. The crash
    was triggered by representable gem's Binding::Map#<< calling
    super(binding) to invoke Array#<< on an Array subclass.

    Add likely_a + coerce_to checks matching the pattern used by
    inline_array_aset. This is a no-op in the normal SendWithoutBlock
    path where the caller already adds a GuardType, but correctly inserts
    the guard when called from InvokeSuper.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 20eeb72085faf196553981b2dacb360f13b927f6
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2026-02-24 02:20:20 +0900
  Commit:     Takashi Kokubun <takashikkbn@gmail.com>
  CommitDate: 2026-02-24 02:20:21 +0900

    Commit a diff shown on check_misc

    https://github.com/ruby/ruby/actions/runs/22316806245/job/64563939588

    Local `make update-man-date` generates nothing but CI complains about
    it, so just pushing this diff to make it happy.

commit 6f0244e0782cfd9f638056b9010a0f8e0495f516
  Author:     Nozomi Hijikata <121233810+nozomemein@users.noreply.github.com>
  AuthorDate: 2026-02-24 02:14:34 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-24 02:14:34 +0900

    ZJIT: Pull GetEP out of GetLocal (with level > 0) (#16215)

    Closes: https://github.com/Shopify/ruby/issues/944

    As a first step toward enabling CSE/LVN-based deduplication of frame EP loads,
    splitting `GetLocal` handling for `level > 0` into an explicit `GetEP + LoadField` path.

    A follow-up PR will handle the `level == 0` case.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit ffbe288f53ca91c61f94788d28df5518ad97434e
  Author:     Tomás Coêlho <36938811+tomascco@users.noreply.github.com>
  AuthorDate: 2026-02-24 02:12:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-24 02:12:24 +0900

    ZJIT: constant fold bitwise XOR (^) operations (#16225)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 107699df9d456955ed2a062f1f26fb654f74c52a
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-24 02:05:44 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-24 02:06:17 +0900

    [ruby/erb] Freeze src in initialize
    (https://github.com/ruby/erb/pull/105)

    https://github.com/ruby/erb/commit/3d4dc31905

commit fd492edd4996f3481949509222224d038c4e3481
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-20 04:12:32 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-23 18:35:13 +0900

    Fix spurious uses of BASE_SLOT_SIZE

    In gc_sweep_plane, VALGRIND_MAKE_MEM_UNDEFINED was using BASE_SLOT_SIZE
    which only covers the smallest pool's slot size. For larger size pools
    this left the tail of the slot with stale state. Use the page's actual
    slot_size instead.

    In gc_prof_set_heap_info, heap_use_size and heap_total_size were computed
    as object_count * BASE_SLOT_SIZE, undercounting memory for objects in
    larger size pools. Sum across all heaps using each pool's actual slot
    size for correct byte totals.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16202

commit 9ebef81e2c75628f07fde169937824376be71351
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-23 18:18:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-23 18:18:44 +0900

    Relax thresholds for compaction verification

    These tests failed with RHEL10 again.

commit b94162ab8a8659013a3b7e0d6881d8a8495f609c
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-03 02:54:40 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-23 01:40:41 +0900

    [ruby/prism] Preserve line-continuation only in dedent heredocs

    Closes https://github.com/ruby/prism/issues/3837

    While these lines are whitespace only from a runtime perspective,
    the line continuation is significant for AST consumers.

    Sort of a followup to https://github.com/ruby/prism/commit/faab217d9382186133862ce4d5ba9a9e090a9550

    https://github.com/ruby/prism/commit/a8a7c6b77d

commit 731b6092e9268af960bf0f060e37504f4deb7380
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-12 21:10:40 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-23 01:38:42 +0900

    [ruby/prism] [Feature #19107] Allow trailing comma in method signature

    https://github.com/ruby/prism/commit/b7e247ce6a

commit 6d69a2b8f40779bbee672ff2fd9ad4247754e040
  Author:     Charles Oliver Nutter <headius@headius.com>
  AuthorDate: 2026-02-05 05:48:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-23 01:32:12 +0900

    [ruby/prism] Rename Java package to org.ruby_lang.prism

    This moves all of the non-JRuby Java code from the org.prism
    package to the org.ruby_lang.prism package (corresponding to the
    ruby-lang.org domain and prism project).

    https://github.com/ruby/prism/commit/80b7402f8b

commit c71999e8cc2e44762b3304f52e5f1eecf6365cfe
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-22 20:00:39 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-22 20:00:39 +0900

    [DOC] Update the date in man pages

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16222

commit dcdec8c28e1540cfa17546d407e10860cb419125
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-22 19:59:43 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-22 19:59:43 +0900

    [DOC] Check if date in man pages is up-to-date

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16222

commit 07645fe82c7e8ef1a6b8864bd30cf45b7ebcef6b
  Author:     Alexander Ziaee <concussious@runbox.com>
  AuthorDate: 2026-02-22 14:34:40 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-22 14:34:40 +0900

    [DOC] man: Increase section number portability

    Remove a zero-width space from manual page section numbers improving
    portability with the mandoc compiler used on macOS, BSD, and illumos.

    Previously it was polluting the whatis(1) database, showing as being
    in both sections `1` and also creating a new section `\&1`.

    This matches the examples shown in the language references for
    the two most widely deployed mdoc(7) compilers, mandoc and groff.

    Signed-off-by: Alexander Ziaee <ziaee@google.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16220

    Merged-By: nobu <nobu@ruby-lang.org>

commit ac4aebc77b2fdb8f5f0248d71fc476173c357dbc
  Author:     tomoya ishida <tomoyapenguin@gmail.com>
  AuthorDate: 2026-02-22 12:44:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-22 12:44:49 +0900

    Use ruby-head instead of ruby-3.2 in check_misc job (#16217)

  Notes:
    Merged-By: tompng <tomoyapenguin@gmail.com>

commit fcba4c1ad753e10dfd86d21b3d3787b522ae8114
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-22 07:20:57 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-22 11:56:06 +0900

    [DOC] Improve link in yjit.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16218

commit 9efde1f24eca01340d7193a19441f15993551cb1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-22 11:06:26 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-22 11:06:26 +0900

    [DOC] Specify the HTML output path explicitly

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16219

commit 60082aa9f7f7e976d901b0566def5830cfa42f24
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 03:32:39 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-22 04:17:24 +0900

    [DOC] Fix link fragment

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16092

commit 727612b138f7a0483d4b747dc1ee917dbe5da700
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-21 21:58:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-21 21:58:46 +0900

    ZJIT: Stabilize anonymous module/class names in stat keys and display (#16176)

    Anonymous modules/classes get names like `"#<Module:0x00007f...>"` from `rb_class2name`, which include a memory address that changes between runs. This makes stat keys unstable for diffing across runs and is less informative than it could be for display.

    Add three variants for class naming:
    - get_class_name: raw rb_class2name (unchanged, for internal use)
    - get_stable_class_name: strips addresses, includes superclass for anonymous classes (e.g. `"#<Class(String)>"`). For stat keys.
    - get_debug_class_name: like stable but preserves address when the name can't be fully resolved (e.g. `"#<Class(String):0x...>"`, `"#<Module:0x...>"`). For display where disambiguation matters.

    Use get_stable_class_name in stat key paths (qualified_method_name and count_call_to). Use get_stable_class_name in display paths that already have a separate pointer via ptr_map. Use get_debug_class_name in display paths without a separate pointer (type specializations, unreachable messages).

    I did this when trying to identify the source of the `#<Module:0x...>#object_id` stat we get from lobsters.  None of these cases handled that (which as we identified was Tempfile using Delegate), so I'm not sure how useful it might be, but it still seemed potentially useful enough to propose and discuss.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit a0d9b69cd3342b38b02a55a652cff9bd272953fd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-20 10:30:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-21 14:31:36 +0900

    colorize: [DOC] Add documents

commit 1fb58853c899883b5ceb115080671b3c446e64d2
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-20 10:29:55 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-21 14:30:42 +0900

    colorize: Make internal methods/constants private

commit 2794351c9f1c2b6b65dac1bb6c978971c064b383
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-20 02:38:45 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-21 14:30:42 +0900

    colorize: Refactor #initialize

    Use keyword arguments and extract repeated regexps as constant.

commit 769b8de476f10d5552cf7c7c10a3d42f7d8d20bc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-20 02:36:16 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-21 14:30:41 +0900

    colorize: Support background color

commit 623f33d92f4a3b0d5d69bd36e0277fc7ecdf730b
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-21 05:28:40 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-21 13:12:51 +0900

    Relax test_thrashing_for_young_objects to fix CI flake

    This test has been failing intermittently on multiple CI platforms
    (Debian 13, RHEL 9/10, Ubuntu aarch64) with heap_allocated_pages
    growing from 100 to 130, or major_gc_count incrementing by 1.

    Failing run: https://rubyci.s3.amazonaws.com/ubuntu/ruby-master/log/20260220T001003Z.fail.html.gz

    The test uses assert_separately, so test ordering is not a factor.
    In failing runs sweep_slots (27,386) lands within ~1,200 of
    min_free_slots (28,652) after warmup.

    I've been unable to reliably replicate this.

    However, when looking at the failures messages all failing runs
    total_freed_pages is 0: pages are not being freed and reallocated in a
    cycle. This is distinct from [Bug #18929] where pages cycled between
    allocation and the tomb heap.

    Since total_freed_pages == 0 already guards against the thrashing
    from [Bug #18929], relax heap_allocated_pages to assert_in_epsilon
    (50% tolerance) and drop major_gc_count which follows from the same
    marginal threshold.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16211

commit 82e796b1ebf5845e60713dbfdab963b6aa23041c
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-21 07:49:51 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-21 13:12:29 +0900

    Revert "[Bug #19831] Remove duplicate library warning"

    This reverts commit d256629bf9e194838d1837be74dcc0b8ff0bcfd6.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16212

commit a8cb7292c6790d12a72000c1e19e62f05ea63f6a
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-20 06:43:32 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-21 08:12:47 +0900

    Remove NUM_IN_PAGE macro

    This is being used to calculate the starting point of the slots in a
    page in order to make them evenly divisible by a bitmap plane.

    Since https://github.com/ruby/ruby/pull/16150 we restructured the
    bitmaps in order to pack them such that 1 bit == 1 slot, and remove the
    masking, meaning that we no longer need to align against planes.

    This is the last remining use for the NUM_IN_PAGE macro so we can remove
    that as well.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16205

commit e730ac41be4d427f06540e0f67fa16bbdced4789
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-21 01:39:11 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-21 01:39:11 +0900

    YJIT: Fix version_map use-after-free from mutable aliasing UB

    Multiple YJIT functions created overlapping `&'static mut IseqPayload`
    references by calling `get_iseq_payload()` multiple times for the same
    iseq. Overlapping &mut is UB in rust's aliasing model, and as consequence,
    we trigered use-after-free on the `version_map` Vec header due to false
    claims of LLVM `noalias`.

    This manifested as crashes in various YJIT operations (block lookup,
    GC marking, block removal) that dereference the stale pointer.

    Fix by moving `delayed_deallocation` and `get_or_create_version_list`
    from free functions (which each call `get_iseq_payload()` internally)
    to methods on `IseqPayload` that operate through `&mut self`. This
    lets callers obtain a single payload reference and use it for all
    operations without creating overlapping mutable borrows.

    The three fixed call sites:

    1. `rb_yjit_tracing_invalidate_all` (invariants.rs): The loop called
       `delayed_deallocation()` which internally called `get_iseq_payload()`,
       creating a second `&mut` overlapping with the outer `payload` reference.
       Fix: call `payload.delayed_deallocation()` method instead.

    2. `add_block_version` (core.rs): Called `get_or_create_version_list()`
       then later `get_iseq_payload()` for pages, creating two references.
       Fix: use a single `get_or_create_iseq_payload()` call then call the
       `get_or_create_version_list()` method on it for both version_map and
       pages access.

    Also adds regression tests exercising tracing invalidation with
    on-stack methods and suspended fibers.

    [alan: edited commit message]
    Reviewed-by: Alan Wu <alanwu@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16128

    Merged-By: XrXr

commit 906176adb49abcd22bb1da082744ea9e413b96d9
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-20 09:55:15 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-02-21 01:04:50 +0900

    ZJIT: zjit-bisect.rb: Pass options with -T for `make test-spec`

    It was passing options to the test harness rather than ruby(1).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16207

commit ee2d90295c59fce739c5850cf8fe3983db14c199
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-20 19:58:01 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-20 20:18:32 +0900

    [ruby/json] Use single quotes for allow_invalid_escape doc

    Instead of using %{} which works like double-quoted string and allows
    escape sequences and in which "other escaped characters (a backslash
    followed by a character) are interpreted as the character", change the
    examples for `allow_invalid_escape` to use single-quotes strings, in
    which "any other character following a backslash [except ' and \] is
    interpreted as is: a backslash and the character itself."

    This makes it clearer the JSON document only includes a single
    backslash.

    https://github.com/ruby/json/commit/a888d6d57b

commit f3d52cb80d931f91f6d598935d669b7ec468b8a8
  Author:     Andrii Furmanets <furmanets.andriy@gmail.com>
  AuthorDate: 2026-02-20 16:05:24 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-20 20:12:52 +0900

    [ruby/rubygems] Document concurrent_downloads in environment command

    https://github.com/ruby/rubygems/commit/927f1e3a0f

commit 986aa6943f3496da6f3414fb418f580333245b05
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-20 19:44:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-20 19:44:00 +0900

    Suppress an uninitialized variable warning

commit 2d2afa8c170703730a58201ad9cf14ff934c453c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-20 10:33:08 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-20 19:25:21 +0900

    Group rubyspec_capiext

commit 3dc80a098c147ac84f66460ee84e6c7ea9e8f1ff
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-20 12:41:13 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-20 17:34:23 +0900

    Removed unnecessary setup for make bundled_gems_spec-run

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16208

commit 3417f8025d1914c4307d19d9a56db62d54494c88
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2026-02-20 16:08:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-20 16:08:05 +0900

    Update bundled gems list as of 2026-02-20

commit 28de927b37681492eeeee1795f4549168fcdf190
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-20 13:25:59 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-20 13:25:59 +0900

    Add win32-registry entries to doc

commit f01f66ca249405ec125ba864e48e51944cc51c6f
  Author:     Lars Kanis <lars@greiz-reinsdorf.de>
  AuthorDate: 2026-02-18 05:23:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-20 13:22:25 +0900

    Move win32-registry from default to bundled gems

    Because win32-registry needs fiddle and fiddle is a bundled gem.

    [Bug #21855]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16189

commit b093886df039ec67ec36173b590435fe39731264
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-20 04:48:19 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-20 13:19:52 +0900

    [DOC] Fix range docs intro

    It's code but not formatted as such

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16203

commit 6ea68a58418e9706f96c871e519d186384c5b694
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2026-02-10 21:48:59 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-20 11:05:07 +0900

    [ruby/rubygems] Don't check whether a plugin needs to be installed:

    - ### Problem

      When Bundler installs gems, it checks whether a gem plugin needs
      to be installed.
      This check (`Dir.glob`) is expensive and is hotspot when profiling
      Bundler.

      ### Details

      Bundler makes a check to see if a gemspec stub exists for the gem
      being installed. If a gemspec stub already exists and its version is
      the same as the gem being installed, then Bundler assumes that the
      gem plugin was already generated in the past and there is no need to
      generate it again.
      This check was added for performance purpose but it's counter
      productive and has the opposite effect.

      The vast majority of gems don't have a plugin and we are incurring
      the cost of doing a `Dir.glob` for *every* gems to account for the
      small percentage of gems that may have a plugin to install.

      So it's actually much faster to always reinstall plugins for the few
      gems that have ones, than to make a check for all gems.

      Another advantage with this change is that if someone accidentaly
      bust the `plugins` folder but don't bust the `specifications` one,
      then Bundler will correctly regenerate plugins (where as before it
      wouldn't).

      I tried running this patch on a Gemfile containing 400 gems and this
      patch shoves around a second.

      ### Solution

      Always install plugins, no matter if one of the same version already
      exist.

    https://github.com/ruby/rubygems/commit/d8d21c7a40

commit b5ccab2093c9bb19ae8564a935e6fd72ec7354cc
  Author:     Kasumi Hanazuki <kasumi@rollingapple.net>
  AuthorDate: 2026-02-20 10:56:50 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-20 10:56:50 +0900

    IO::Buffer#locked: Release lock even when the block raises (#16180)

    IO::Buffer#locked: Release lock even when the block raises/breaks

    Previously, `IO::Buffer#locked` leaks the lock when the block raises
    an exception, or breaks.

    Fixes: [Bug #21882]

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit 126b657bd103a1abf4b572ade557ffdc7ae99982
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-20 08:09:42 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-20 10:39:44 +0900

    Use rb_ensure instead of guard objects for Dir.pwd

    This replaces GC-based buffer guards (rb_imemo_tmpbuf,
    TypedData_Wrap_Struct) with rb_ensure to clean up malloc/xmalloc memory
    when an exception occurs.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16206

commit 06c8b1abfa45cabb1974411f519975dde59dacc9
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-20 06:04:44 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 08:37:39 +0900

    ZJIT: Remove find() from po_from

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16204

commit c0c97c0f1253120741bc53eaea395c38909b2b8f
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-20 05:59:40 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 08:37:39 +0900

    ZJIT: Simplify po_from to take a single BlockId

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16204

commit e6f73fcf49179472a532ab2ca26d8a0903be5b21
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-18 21:42:15 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-20 08:22:33 +0900

    Remove HEAP_PAGE_OBJ_LIMIT

    This was useful when there was only a single size pool to have an easy
    way of referencing the average number of objects a page could hold (this
    would vary by a few in real terms because of page alignment).

    But with multiple heaps, each heap contains pages with different numbers
    of objects because slot sizes are different.

    So when we use HEAP_PAGE_OBJ_LIMIT to do any kind of calculations: such
    as calculating freeable pages), then we're significantly underestimating
    the number of freeable pages in the larger size pools, which will cause
    us to hold on to pages unnecessarily.

    This commit replaces uses of HEAP_PAGE_OBJ_LIMIT with a more accurate
    approximation for the actual heap being manipulated.

    It also removes HEAP_PAGE_OBJ_LIMIT from GC::INTERNAL_CONSTANTS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16199

commit 7ca0aa5f73303268fbc3589c1ba792c7389cb4c1
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-17 01:47:50 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-20 07:24:11 +0900

    Copy terminator when moving strings to the heap.

    The embedded-to-heap path copied RSTRING_LEN(str) bytes into an
    ALLOC_N buffer, missing the null terminator (and any slot padding).
    Copy str_embed_capa(str) bytes instead. Always safe since we only
    enter this path when str_embed_capa(str) < capacity + termlen.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16201

commit bb8881f31ee1367f50d228e970bdf2dfddd25e18
  Author:     Andrii Furmanets <furmanets.andriy@gmail.com>
  AuthorDate: 2026-02-19 04:12:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-20 07:17:54 +0900

    [ruby/rubygems] Honor concurrent_downloads from gemrc

    https://github.com/ruby/rubygems/commit/6a187a0a99

commit b205bf613ff56d21dcaa315c08d577c0a7a056dd
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-19 01:09:48 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 06:18:49 +0900

    ZJIT: Measure how much each part of compile-time costs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16193

commit 607af489a2f3fa3e3eeee5834517c89b38367409
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-19 00:16:48 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 06:18:49 +0900

    ZJIT: Measure side-exit compile time

    Also report it as a percentage of overall compile time.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16193

commit c058a98866d59072ea0dc6009c2b5d4da9a566d2
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-20 03:05:41 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 06:05:08 +0900

    ZJIT: Replace dominator set-intersection with Cooper's idom algorithm

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16200

commit f5782840a3c03eaf5682a2e096741f5e8cf3a574
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-19 10:08:30 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 06:05:08 +0900

    ZJIT: Add Entries superblock as single CFG root

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16200

commit 3f5e85bf04daeef79a0c158f90a9817eaeb0d263
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-19 09:43:42 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 06:05:08 +0900

    ZJIT: Add LoadArg instruction for JIT entry blocks

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16200

commit e7cff2e817cddee889cfa3a1e7770cf23e1bb667
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-18 09:36:12 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 00:57:10 +0900

    ZJIT: Register builtin CMEs before prelude to avoid prepend crash

    Split rb_zjit_init into rb_zjit_init_builtin_cmes (called before
    ruby_init_prelude) and rb_zjit_init (called after). The prelude may
    load bundler via BUNDLER_SETUP which can call Kernel.prepend, moving
    core methods to an origin iclass. Registering method annotations
    before the prelude ensures we capture CMEs while core classes are
    pristine.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16190

commit bf3bc12d388b0064ecbccf80b1503ce479611f0f
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-19 04:17:15 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 00:57:10 +0900

    Simplify Kernel prepend test

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16190

commit b9dc0a2bb8d08980aa98cf09a6e8615adcd8ffd4
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-18 22:19:02 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 00:57:10 +0900

    Add regression test for module prepend crash

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16190

commit a19becac5b3c0a477fc1883cdd7f9d7195d84349
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-18 09:32:33 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-20 00:57:10 +0900

    YJIT: Register builtin CMEs before prelude to avoid prepend crash

    Split rb_yjit_init into rb_yjit_init_builtin_cmes (called before
    ruby_init_prelude) and rb_yjit_init (called after). The prelude may
    load bundler via BUNDLER_SETUP which can call Kernel.prepend, moving
    core methods to an origin iclass. Registering method codegen before
    the prelude ensures we capture CMEs while core classes are pristine.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16190

commit e7a098457a3fb5ff38374aede03cd32c8682f73b
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-19 21:20:18 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-19 21:31:59 +0900

    [ruby/json] Add `allow_invalid_escape` parsing option

    Ref: https://github.com/ruby/json/issues/939

    https://github.com/ruby/json/commit/05cec0cbee

commit e67f3f06601410fd0fc4ff01b9005e4f4a5b8383
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-19 18:31:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-19 19:58:26 +0900

    [ruby/prism] Implement noblock for the ripper/ruby_parser translator

    In ripper, compared to `**nil` it is not a new event

    https://github.com/ruby/prism/commit/7f5782392e

commit 7d05c17069f7f14255a47553729b942d1cb92800
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-19 19:02:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-19 19:02:57 +0900

    Use `UNREACHABLE_RETURN` instead of dummy `return`

commit 361644c0cce3235e9cc6724994c6b5711deb10b8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-19 17:54:00 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-19 18:12:13 +0900

    [Bug #21917] Fix build on AIX

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16197

commit 3ad0519534fea2e7065136185675a1b54caadcdf
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-19 17:27:32 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-19 18:12:12 +0900

    Reduce duplicate code

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16197

commit 6bb0b6b16c61e8733ce7830cc5f796c64d5398cd
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-19 18:03:55 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-19 18:04:23 +0900

    [ruby/prism] Revert "[DOC] Add code fences"
    (https://github.com/ruby/prism/pull/3936)

    This reverts commit https://github.com/ruby/prism/commit/641775e5fea6.

    There is no need, they are not documented.

    https://github.com/ruby/prism/commit/6fb4c42637

commit da767cda10a25566e91d7ca6956301c94c8bc7ed
  Author:     Stan Lo <stan001212@gmail.com>
  AuthorDate: 2026-02-19 10:15:43 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-19 10:15:43 +0900

    Fix wrong function names in `rb_bug` messages in vm_trace.c (#16196)

  Notes:
    Merged-By: st0012 <stan001212@gmail.com>

commit e3183164a5549d21526cf9b8905a885814a580a0
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-19 09:22:16 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-19 09:22:16 +0900

    ZJIT: Save VM state before recording exit stack for trace-exits (#16195)

    When --zjit-trace-exits is enabled, rb_zjit_record_exit_stack was called before compile_exit restored the VM state (cfp->pc, cfp->sp, stack, locals). This ccall clobbers caller-saved registers that may hold stack/local operands, causing garbage values to be written to the VM stack when compile_exit runs afterward. This led to crashes like `klass: T_FALSE` in the interpreter when those corrupted values were used as receivers.

    Fix by splitting compile_exit into compile_exit_save_state and compile_exit_return, and emitting the full exit inline when recording: save VM state first, then call rb_zjit_record_exit_stack (so rb_profile_frames sees valid cfp->pc), then return.

    Before this I was able to cause a crash with
    ```
    ruby --zjit-trace-exits -rffi -e1
    ```

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit e11c3cef1b0c44562f710e160a4ca7c12a7c348b
  Author:     Nathan Froyd <froydnj@gmail.com>
  AuthorDate: 2026-02-19 06:59:13 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-19 08:37:17 +0900

    [ruby/prism] add `extern "C"` wrappers to `prism.h` when using C++

    https://github.com/ruby/prism/commit/003ff5341d

commit 671ea6fb3ea64caad64bd2955bdd562673a651f9
  Author:     Steven Webb <steven.daniel.webb@gmail.com>
  AuthorDate: 2026-02-19 07:12:31 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-19 07:12:31 +0900

    ZJIT: Constant fold modulus (%) operations (#16168)

    Similar to the way ZJIT already folds +, -, and * operations. One
    complication is that the % operator behaves differently in Ruby than in
    Rust for negative values. For example in Ruby:

    ```
    ruby -e "puts 11 % -3" # => -1
    ```

    vs Rust:

    ```
    println!("{}", 11 % -3); // => 2
    ```

    Rust has the `#rem_euclid()` method; however, it also differs from Ruby.

    My solution was to call into the cruby #rb_fix_mod_fix method to get the
    correct behaviour.

    Note that any `% 0` operations are not folded as they need to raise a
    ZeroDivisionError.

    One concern was an integer overflow. Fortunately that's not possible.
    Given any two Fixnums `a`, and `b`, by definition the result of `a % b`
    must be closer to 0 than `b`, making an overflow impossible.

    One adjacent edge case is when calculating `RUBY_FIXNUM_MIN % -1`. The
    result is 0 which is obviously fine; however, the related result of
    `RUBY_FIXNUM_MIN / -1` would overflow. The #rb_fix_mod_fix method avoids
    this problem by not calculating the `div` portion. See:
    https://github.com/ruby/ruby/blob/07f5126c104507ec70c5bfb2eb5204ceb22b7ebd/internal/fixnum.h#L164

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit e1f49ff79ded5737b0455cd6363e05a2551e7b8b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-17 03:18:19 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-19 05:56:04 +0900

    Don't attempt to convert strings to hashes in gsub

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16182

commit 6273827196cd872549e4e49411230c82d1f86547
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2026-02-17 13:04:16 +0900
  Commit:     Jeremy Evans <code@jeremyevans.net>
  CommitDate: 2026-02-19 03:06:43 +0900

    Remove key_addr argument to set{,_table}_insert_wb

    After a review of all callers, this doesn't appear to be needed for
    correct behavior. We could potentially have a future case where it
    is needed, such as a method that inserts a record into the set and
    returns the inserted record (which could be different from the
    argument if the argument was an unfrozen string). However, we don't
    currently have such a case, and it's better for performance to
    remove the code.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16188

commit 219ad6823a4d0020f49aed9f562e19b40ca4c40e
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-11 07:30:06 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-02-19 00:16:43 +0900

    ZJIT: Don't specialize `super` from within a block

    As we found out from YJIT, `super` from within a block needs a loop for
    the running CME guard, and the current LEP based guard always fails.
    Don't specialize for now so we use the fallback instead of side-exiting.

commit ea7d3eb89b8c5192c0cf9a885a17b0aeaef1067a
  Author:     Alan Wu <XrXr@users.noreply.github.com>
  AuthorDate: 2026-02-10 06:46:50 +0900
  Commit:     Alan Wu <XrXr@users.noreply.github.com>
  CommitDate: 2026-02-19 00:16:43 +0900

    YJIT: Fix always-failing guard for `super()` in BMETHODs

    Previously, when dealing with a `super()` nested in a block that runs as
    a method (through e.g. `define_method`), YJIT generated a guard that
    never passes leading to a misidentification of the callsite as
    megamorphic and an unconditional interpreter fallback.

    The issue was in the subroutine to find the currently running method
    entry. In the interpreter, this is rb_vm_frame_method_entry(). YJIT used
    `gen_get_lep()` to find the EP with `VM_ENV_FLAG_LOCAL`, but in case
    of BMETHODs, the corresponding CME is never at an EP level with
    `VM_ENV_FLAG_LOCAL` set.

    Because each block nesting level can dynamically run as either a BMETHOD
    or not, starting at a block and finding the first EP that has a method
    entry ultimately requires a search loop such as the one in rb_vm_frame_method_entry().
    This patch introduces such a loop.

    Because `invokesuper` in a block can now work end-to-end, add check for the
    previously masked "implicit argument passing of super from method
    defined by define_method() is not supported..." condition.

commit d256629bf9e194838d1837be74dcc0b8ff0bcfd6
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-16 19:59:50 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-18 22:04:51 +0900

    [Bug #19831] Remove duplicate library warning

    When building on macOS, we get a warning about duplicate libraries

        ld: warning: ignoring duplicate libraries: '-ldl', '-lobjc', '-lpthread'

    To fix it, we now append $(MAINLIBS) to LIBRUBYARG_SHARED (when shared
    is enabled), matching what's already done for LIBRUBYARG_STATIC. And we
    remove the now-redundant $(MAINLIBS) from the $(PROGRAM) link line,
    since $(LIBRUBYARG) carries it in both cases.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16181

commit 4cb6e9d0ac272d9bc2c0d621cf65b1314cd09e7b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-18 19:01:29 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-18 19:01:29 +0900

    Pass the global variable with `-s` option

commit 91be23cd961aa937701214ba5f50c698301c5e26
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-14 21:39:59 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-18 17:19:56 +0900

    [Bug #21868] Use ruby allocator for prism

    If we wan't prism to use the ruby allocator, we should
    include it as early as possible.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16174

commit 4797b060c88f58688a6d5b58719aec63a6677510
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-18 13:28:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-18 16:23:27 +0900

    test-bundled-gems: Use the abstract decoration

commit ea0432f793b73820a932863d7c4eaf58fe8122dc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-18 12:21:01 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-18 16:23:27 +0900

    colorize: Reset for each attribute

commit b7c770c038ef0fe033f9e82bd7c9a004b14d8200
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-18 15:25:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-18 15:25:41 +0900

    Clean timestamp directory

    Fix up git:e875ca2e7494.

commit b6ef00094edd51d1ad0548ed5f55eb02079b9e22
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-18 15:05:30 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-18 15:05:30 +0900

    Skip failing example in spec/bundler/install/global_cache_spec.rb when running in ruby core

commit e9806c21de6094c464c0196397d72d2f84298ece
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-18 13:34:05 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-18 13:34:05 +0900

    ZJIT: Count side-exit code size and report ratio to code region (#16191)

    railsbench stats:
      side_exit_size:       5,340,736
      code_region_bytes:   15,122,432
      side_exit_size_ratio:     35.3%

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit f70f8338e3e43708349fdf069e7deac2d11c18c4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-17 23:30:01 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-18 11:12:29 +0900

    Direct calls for specific numeric types in complex/rational

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16192

commit a4a6de0b17b515e814de0be9f931e70808124dfc
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2026-02-17 08:28:47 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-18 10:17:44 +0900

    [ruby/rubygems] Fix Bundler crashing when it tries to install plugin:

    - ### Problem

      Bundler crashes when a Gemfile contains a plugin and you
      try to run `bundle install` while setting the BUNDLE_WITHOUT=default
      value.

      ### Context

      Setting the BUNDLE_WITHOUT=default is something that some deployment
      tooling does like [shipit](https://github.com/Shopify/shipit-engine/blob/a24b9d8b1b777e22f05311705be7938a4823eee6/app/models/shipit/deploy_spec/bundler_discovery.rb#L6)
      The intent being to only install gems that are required to deploy
      the app (for instance ones that are inside a `group :deploy` block).

      ### Solution

      Bundler assume that all plugins inside the Gemfile will get
      installed, but don't take in consideration that a BUNDLE_WITHOUT
      may have affected this.

      So before registering a plugin, make sure it's actually in
      the `specs` object (meaning it was installed on disk).

    https://github.com/ruby/rubygems/commit/b416a026ca

commit 4ab288f9d467c83507693051229784bba961e3c1
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-17 17:29:33 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-18 10:16:51 +0900

    Clean temporary files generated by test-bundler

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16186

commit e4b8ca2a3e62af89eb9e42ab87a488433361bc85
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-17 17:28:56 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-18 10:16:51 +0900

    Show gem names at fetching

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16186

commit e875ca2e7494e7c28af6dbf0ad0add5c81d6944c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-17 09:04:34 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-18 10:16:51 +0900

    Fetching bundled gems sources depending on default_gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16186

commit f0343743990497e15501ede6841524ac5ca1e0f8
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-17 09:03:38 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-18 10:16:51 +0900

    test-bundled-gems-spec does not need rubyspec CAPI exts

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16186

commit 633a9bc7e961dbabba3601a6056cfdc2c0c65421
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-16 16:45:37 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-18 10:16:51 +0900

    Show elapsed times in test-bundled-gems

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16186

commit 282f57a2bcb56bdd6f84533660a4aa56124e0a63
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-18 07:48:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-18 07:48:22 +0900

    Upgrade the latest version of github/codeql-action

commit 997bc709db321db9bd250aa889dda6279c20148e
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-18 00:39:42 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-18 05:46:23 +0900

    Re-enable the Lobste.rs benchmark on CI

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16187

commit 55ecc9c1a512f384926a8f9c6730d86ed02debdd
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2026-02-17 22:51:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 23:20:38 +0900

    [ruby/prism] Recompile when config.yml changes

    * Fixes https://github.com/ruby/prism/issues/3931.
    * The first line is the default one, we want to keep that default dependency too.
    * Some docs about this: https://docs.ruby-lang.org/en/4.0/MakeMakefile.html

    https://github.com/ruby/prism/commit/ffe8f7a6e2

commit a9237d128ef2f72d86551505b303e3d988d7f320
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-17 18:11:05 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-17 22:40:55 +0900

    Rename `pm_newline_list_t` to `pm_line_offset_list_t`

    Co-Authored-By: Nathan Froyd <froydnj@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16184

commit 4f5805fd61974bf654164e205d24b6091d6ba89b
  Author:     Edouard CHIN <chin.edouard@gmail.com>
  AuthorDate: 2026-02-10 09:11:58 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 19:13:37 +0900

    [ruby/rubygems] Run git operations in parallel (take 2):

    - In #9100, I opened a patch to run git operations in parallel in
      order to download git gems more quickly.
      The parallelization doesn't works when resolving is not needed due
      to a premature call to `source.specs` hit by this codepath.

      You can reproduce the problem and see that the gems aren't
      downloaded in parallel if you have an existing Gemfile and
      Gemfile.lock. (In my first patch, I forgot to try when a
      Gemfile.lock already existed).

      I'd like to introduce a new call to `prelad_git_sources`, when
      bundler hits the "missing specs" branch.
      I unforunately couldn't find a single place where we could preload
      git sources due to the `source.specs` that is called at different
      path.

    https://github.com/ruby/rubygems/commit/f25b40f21f

commit 3896dbc9ee0b69d84a7805ae2bbc476d3ad3d8c4
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-17 15:01:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-17 15:01:02 +0900

    Extend timeout for test_undefine_finalizer

    https://ci.rvm.jp/results/trunk-yjit@ruby-sp2-noble-docker/6204308

commit 125b3ad93f53300b289bec4fa57aa23417d7e305
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-17 11:38:25 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-17 11:38:25 +0900

    Extend timeout for test_move_nested_hash_during_gc_with_yjit

    https://ci.rvm.jp/results/master-no-rjit@ruby-sp2-noble-docker/6204075

commit 1fbe6214ad17bf335b690433c1abc5a05e2ce049
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-02-17 01:16:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 05:49:32 +0900

    [ruby/prism] Parser support for no block parameter syntax

    https://github.com/ruby/prism/commit/675f9c3be7

commit 387faae7844001ebaf85b62743f9c5d0632e4c14
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-17 03:37:35 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 05:33:32 +0900

    [ruby/prism] Add a test for multiple `&nil` blocks/mixing them

    https://github.com/ruby/prism/commit/e5fb0e192b

commit 7135ab56c8d13b9e5a5242c6ac97ea4643a637a1
  Author:     Kevin Newton <kddnewton@gmail.com>
  AuthorDate: 2026-02-17 01:00:47 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 05:33:32 +0900

    [ruby/prism] Only accept noblock in Ruby 4.1+

    https://github.com/ruby/prism/commit/fb88c72dce

commit f5f9fe243535d19af6a7e78ccd456f75fe990ac1
  Author:     Kazuki Yamaguchi <k@rhe.jp>
  AuthorDate: 2026-02-17 01:44:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 01:59:15 +0900

    [ruby/openssl] Ruby/OpenSSL 4.0.1

    https://github.com/ruby/openssl/commit/38a1a4a8f0

commit 0eff3a26236ff5039f4497969f62feffc9f5259c
  Author:     Steve Whittaker <stevew@ssl.com>
  AuthorDate: 2026-02-17 00:58:48 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 01:39:21 +0900

    [ruby/openssl] ocsp: fix uninitialized variables in BasicResponse#status

    revtime, thisupd, nextupd, and reason are not initialized before
    being passed to OCSP_single_get0_status(). For GOOD and UNKNOWN
    status, OpenSSL doesn't write to revtime or reason (only REVOKED
    does), so they keep whatever was on the stack. The nil guard
    `revtime ? asn1time_to_time(revtime) : Qnil` then tries to
    convert a garbage pointer, which blows up with ASN1_TIME_to_tm.

    Initialize all four to safe defaults before the call.

    https://github.com/ruby/openssl/commit/667ce07f33

commit 38c602ea0092abeef3e679fdc88961cb77492448
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-16 23:43:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-17 00:49:22 +0900

    [ruby/prism] Fix C extension docs in ruby/ruby

    Because ruby/ruby doesn't use our rake task it also uses the default markup (rdoc), unless specified otherwise.
    github.com/ruby/prism/pull/3572 already added it explicitly to ruby files.

    For C however, it is not so easy because of a rdoc bug: https://github.com/ruby/rdoc/issues/1597
    Adding the comment would remove all documentation since it gets parsed as ruby.

    So, specify it for each method individually. Remove it from the template since there is only one C file relevant for rdoc.

    https://github.com/ruby/prism/commit/4ee9b1b651

commit 11e4f99a4ef3096c59f7b221865fbbe11b4cb1ed
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-16 17:03:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-16 17:25:57 +0900

    [ruby/prism] Only compare &nil syntax on rubies that support it

    https://github.com/ruby/prism/commit/8aad2480ab

commit 66a3ebe38065509ae83e56095eaaf146d82efe9d
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2026-02-16 14:37:35 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-16 14:37:35 +0900

    Update bundled gems list as of 2026-02-16

commit 99674185d63162eadcded3d2623a181fddf2bbb3
  Author:     Ufuk Kayserilioglu <ufuk.kayserilioglu@shopify.com>
  AuthorDate: 2024-06-27 06:38:01 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-16 04:12:15 +0900

    Start handling `&nil` in method parameters

    Similar to `:nokey` for `**nil` declaring methods/procs, a method/proc with a `&nil` declaration will return a `:noblock` entry in the parameters array.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/11065

commit 071c6d149b8e67960ba809089c3736926620c40e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-02-21 12:36:01 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-16 04:12:15 +0900

    [PRISM] [Feature #19979] Method definition with `&nil`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/11065

commit 116d402067c1d01ed67b16ec93fb523bd5109d07
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2024-02-20 19:34:50 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-16 04:12:15 +0900

    [Feature #19979] Method definition with `&nil`

    Allow methods to declare that they don't accept a block via `&nil`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/11065

commit 2065b55980a0fc6386d58e4ede37d60c50e5b62f
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2026-02-14 16:03:18 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-14 16:03:18 +0900

    Update bundled gems list as of 2026-02-14

commit b5105f16f9ed6547aaa3f0808b706bca91e4faf4
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-14 00:28:05 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-14 09:20:28 +0900

    [DOC] Fix example of unpack ^ directive

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16171

commit 93e68cacc8dde243d8ece47ee73206e0ca334705
  Author:     Godfrey Chan <godfreykfc@gmail.com>
  AuthorDate: 2026-02-14 06:30:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-14 06:30:39 +0900

    ZJIT: unify `hir::Insn::{Send,SendWithoutBlock}` (GH-16143)

    After GH-15911, we largely apply the same treatment to these two
    variants everywhere. In `type_specialize`, there are two ~100 LOC
    match arms that shared 90% of the code. Unifying these allowed the
    code to be shared more easily.

    ---

    **Note:**

    In the interest of preserving existing semantics and keeping the
    diff small for this initial PR, `YARVINSN_send` can currently
    produce:

    ```rs
    Insn::Send { blockiseq: Some(null_ptr), .. }
    ```

    Either way, that can be done in a follow-up PR.

    ---

    Follow-up tasks:

    1. Unify `reduce_send_to_ccall`/`reduce_send_without_block_to_ccall`

    2. Address the `Some(null_ptr)` situation above (discussed on PR)

    3. Rename/merge the stats/counters/fallback reasons, if desired

    Partially addresses Shopify/ruby#941 (TODO: `optimize_c_calls`)

    [alan: rewrote commit message]
    Reviewed-by: Alan Wu <XrXr@users.noreply.github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16143

    Merged-By: XrXr

commit bf1ac3f4af16edb613b6795a4af253e9d551bd2c
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-13 18:49:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-14 01:38:48 +0900

    [ruby/prism] Fix lexing for unterminated strings/heredocs etc.

    When we hit EOF and still have lex modes left, it means some content was unterminated.
    Heredocs specifically have logic that needs to happen when the body finished lexing.
    If we don't reset the mode back to how it was before, it will not continue lexing at the correct place.

    Followup to https://github.com/ruby/prism/pull/3918.
    We can't call into `parser_lex` since it resets token locations.

    https://github.com/ruby/prism/commit/27c24fdc0d

commit 2daf48e724d59ff0094a8d7ff9af9936ca5c84ab
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-13 22:37:49 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-13 23:29:14 +0900

    Use UINT32_MAX as magic divisor

    As @jhawthorn pointed out, the original calculation used `(1 << 32) /
    heap->slot_size + 1)` which leads to a subtle off by one error that gets
    shifted away because our slot sizes aren't powers of 2.

    This is still worth fixing now, so that we don't trip up over it if we
    change slot sizes in the future.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16150

commit b53aada8da9615b4818da3d87dd92a5f2aea89b8
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-11 21:12:20 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-13 23:29:14 +0900

    We can't actually hardcode these

    because BASE_SLOT_SIZE changes on 32 bit, and when debug/devel symbols
    are added

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16150

commit 20d85bbe9b0234c83d64dc1fc853e92cc80a2672
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-06 08:23:34 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-13 23:29:14 +0900

    Make sure we clear the bits when adding a new page

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16150

commit 1b65282961de25380d4c6e34d249136d0ea1fa5c
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-04 04:39:48 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-13 23:29:14 +0900

    hardcode and look up magic numbers

    instead of computing them on page add

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16150

commit 5c71c8c55bd71cff64e670097e4800d9e3d67ae4
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-02-04 03:51:35 +0900
  Commit:     Matt Valentine-House <matt@eightbitraptor.com>
  CommitDate: 2026-02-13 23:29:14 +0900

    gc: implement slot-based bitmap indexing with division magic

    Replace the BASE_SLOT_SIZE-granularity bitmap scheme with slot-based
    indexing where each bit represents one slot regardless of size.

    Key changes:
    - Add slot_div_magic field to heap_page for fast division
    - Use Go-inspired formula: slot_index = (offset * div_magic) >> 32
    - Update all bitmap iteration to use one-bit-per-slot scheme
    - Remove slot_bits_mask from rb_heap_t (no longer needed)

    This enables arbitrary slot sizes (not just power-of-two multiples of
    BASE_SLOT_SIZE) by decoupling bitmap indexing from slot size.

    Functions updated:
    - gc_sweep_plane/gc_sweep_page
    - rgengc_rememberset_mark/rgengc_rememberset_mark_plane
    - gc_marks_wb_unprotected_objects/gc_marks_wb_unprotected_objects_plane
    - gc_compact_plane/gc_compact_page
    - invalidate_moved_plane/invalidate_moved_page
    - RVALUE_AGE_GET/RVALUE_AGE_SET_BITMAP

    Inspired by Go runtime's mbitmap.go divideByElemSize().

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16150

commit c9a49411dcfa6ac42d15ce33858207cb4b11025e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-13 20:04:08 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-13 21:19:52 +0900

    Dir.scan: fallback to `lstat` when encountering DT_UNKNOWN

    This was part of the spec accepted in [Feature #17001] but that
    I forgot to include in the initial implementation.

    to ensure coverage, we always go though the fallback path in debug
    mode.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16170

commit 72beb17df04b0a2915d880bcabd814351d3c5297
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-13 18:05:35 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-13 18:41:55 +0900

    spec/mspec/tool/wrap_with_guard.rb 'ruby_version_is ""..."4.1"' spec/ruby/library/net-ftp/**/*.rb

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16169

commit aa2dd36131b22221be37a7925eb5c30545020668
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-13 17:52:23 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-13 18:41:55 +0900

    Removed net-pop

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16169

commit 22408088ff37fd6e2c8a27d3a1af03ef78e440fd
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-13 17:51:57 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-13 18:41:55 +0900

    Removed net-ftp

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16169

commit 13d14c6a9cbb7b9dca7e06b8ccd10bf4c47520bb
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-12 18:22:37 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-13 16:01:30 +0900

    Freeze `File.ftype` results

    It is unlikely to modify these result strings.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16166

commit 74c066a711972ba0927d980ce0010ec68c77e74e
  Author:     Luis J. Gonzalez <lgonzalez@sonatype.com>
  AuthorDate: 2026-01-27 04:39:00 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:53:50 +0900

    [ruby/rubygems] Add support for custom error response from external registries

    https://github.com/ruby/rubygems/commit/b021dde989

commit f94f28481b8450c0dfa18304be420fd969321b7e
  Author:     Garen J. Torikian <gjtorikian@users.noreply.github.com>
  AuthorDate: 2025-02-21 23:00:24 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:15 +0900

    [ruby/rubygems] remove outdated rubies

    https://github.com/ruby/rubygems/commit/98a50203cb

commit e0ab4157877c737b775610a7d885de28bed577ef
  Author:     Garen J. Torikian <gjtorikian@users.noreply.github.com>
  AuthorDate: 2025-02-09 06:17:50 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:14 +0900

    [ruby/rubygems] update template dependencies

    https://github.com/ruby/rubygems/commit/a7f52d6b02

commit fe25c2cbacf66dfd75790042b02d2bde51092936
  Author:     Ian Ker-Seymer <ian.kerseymer@shopify.com>
  AuthorDate: 2024-05-31 12:30:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:14 +0900

    [ruby/rubygems] Remove hard coded constant

    https://github.com/ruby/rubygems/commit/da14b90859

commit 211c17dcac82fec630bd6e57d362abbf6f281eae
  Author:     Ian Ker-Seymer <ian.kerseymer@shopify.com>
  AuthorDate: 2024-05-31 12:22:16 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:13 +0900

    [ruby/rubygems] Support precompiled rust gems out of the box

    https://github.com/ruby/rubygems/commit/5d3fbf0280

commit e785e466daab8c85d8e6cdfb05fa43c488e74db2
  Author:     Ian Ker-Seymer <ian.kerseymer@shopify.com>
  AuthorDate: 2024-05-31 12:03:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:13 +0900

    [ruby/rubygems] Improve testing config

    https://github.com/ruby/rubygems/commit/92e28403c3

commit c0d4f3e92dbfd7744b12c1f0fbb11fcee3ef1313
  Author:     Ian Ker-Seymer <ian.kerseymer@shopify.com>
  AuthorDate: 2024-05-31 11:34:00 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:12 +0900

    [ruby/rubygems] Default to using rb_sys for Cargo gem builds

    https://github.com/ruby/rubygems/commit/fb3f1febcf

commit 54ffff05f9f5422b018ee64028f808a8d2bda011
  Author:     Ian Ker-Seymer <ian.kerseymer@shopify.com>
  AuthorDate: 2024-05-31 11:33:12 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:12 +0900

    [ruby/rubygems] Include debug symbols by default in release builds for rust gems

    https://github.com/ruby/rubygems/commit/26e419f157

commit 27204dc8ccd028d4c670be572d2c70abf41f1ce2
  Author:     Ian Ker-Seymer <hello@ianks.com>
  AuthorDate: 2024-04-25 11:52:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:28:11 +0900

    [ruby/rubygems] [rust gem] Make cargo test work by default

    https://github.com/ruby/rubygems/commit/9420974db7

commit 5d40a6d5875cd740912e115eb6cfa869bb9c875f
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-01-26 15:31:35 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:19:28 +0900

    [ruby/rubygems] bin/rubocop -a --only Style/HashSyntax

    https://github.com/ruby/rubygems/commit/00db7f4522

commit 7e20c950933821dc1ee51f0f1d5d41706206ea24
  Author:     Abdelkader Boudih <terminale@gmail.com>
  AuthorDate: 2026-01-05 18:15:31 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 15:19:27 +0900

    [ruby/rubygems] fix(bundler): only preload git sources for requested groups

    Skip fetching git sources for excluded groups (--without). This is
    important for production builds where development git dependencies
    may be private repos without access, or should not be included in
    Docker images.

    https://github.com/ruby/rubygems/commit/d034ee10bb

commit 00440871dbe648cf7f8e2ebc2f01d3b1e0024cd6
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-13 13:53:57 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 14:29:05 +0900

    [ruby/rubygems] Relax gem name validation to warn on capital letters

    https://github.com/ruby/rubygems/commit/26dab848c5

commit e064d0d92518209329297cb756f22a2287efd25a
  Author:     OKURA Masafumi <masafumi.o1988@gmail.com>
  AuthorDate: 2022-03-27 22:26:09 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 14:29:04 +0900

    [ruby/rubygems] Raise error when gem contains capital letters

    The problem is described in https://github.com/rubygems/rubygems/issues/5431
    The guide ( https://guides.rubygems.org/name-your-gem/ ) says
    > DON’T USE UPPERCASE LETTERS
    so `bundle gem` command should respect it.

    https://github.com/ruby/rubygems/commit/ea1b1e2209

commit 3dc8ce28b017389eaa3caf0e79823b5330616f13
  Author:     copilot-swe-agent[bot] <198982749+Copilot@users.noreply.github.com>
  AuthorDate: 2026-01-26 17:21:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 12:09:16 +0900

    [ruby/rubygems] Add test for bundle help greet command

    https://github.com/ruby/rubygems/commit/602b0cecb8

    Co-authored-by: hsbt <12301+hsbt@users.noreply.github.com>

commit 5d39c1a41f6a86f4cbab325a6ba7bcdc6aadc831
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-01-26 17:01:07 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 12:09:16 +0900

    [ruby/rubygems] Add support for help flag in plugin commands

    https://github.com/ruby/rubygems/commit/b8d45956d0

commit 6dbece090f74345c404b644445563d900cabb147
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-13 11:45:42 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 11:46:09 +0900

    [ruby/stringio] [DOC] Japanese for multi-byte characters
    (https://github.com/ruby/stringio/pull/201)

    https://github.com/ruby/stringio/commit/26d8f60053

commit d1535862bc1a66c783ce8d8558619b8c853ea420
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-13 10:32:49 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-13 11:22:20 +0900

    Skip shipit benchmark because sassc is not working with artifact under the ext directory.

    https://github.com/ruby/ruby/actions/runs/21970480259/job/63470652855

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16164

commit be8f647bdab59d16554900c16c101e453863918d
  Author:     Nery Campusano <nery.campusano@shopify.com>
  AuthorDate: 2026-02-13 06:35:26 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-13 11:01:50 +0900

    [Bug #21551] changing the exception to be isolationerror rather than argument error

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16163

commit 2233822f3fb6583df4740dd88feaa337f49f05a6
  Author:     copilot-swe-agent[bot] <198982749+Copilot@users.noreply.github.com>
  AuthorDate: 2026-01-09 13:03:42 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 10:00:01 +0900

    [ruby/rubygems] Add assertion for install_extension_in_lib default value in test_initialize

    https://github.com/ruby/rubygems/commit/cf8c9ee82b

    Co-authored-by: hsbt <12301+hsbt@users.noreply.github.com>

commit 7a88a9085d15bed53aff722657d8a0bc955dd042
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-01-09 12:30:13 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 10:00:00 +0900

    [ruby/rubygems] Make DEFAULT_INSTALL_EXTENSION_IN_LIB false by default to stop installing extensions into lib directory

    https://github.com/ruby/rubygems/commit/1614b036f7

commit a88475d6cb6c6a917b56be496cb83733cadd1d27
  Author:     Prajjwal Singh <sin@prajjwal.com>
  AuthorDate: 2026-02-12 07:28:09 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-13 09:46:09 +0900

    Report all missing modular GC exports before exiting

    Make `ruby_modular_gc_init()` print all symbol import errors instead of
    bailing on the first one. That way, GC authors don't have to fix one
    symbol at a time.

    Also accumulates and prints the total error count across all imports.

    Eg.

    On a sample GC ripped from the built-in GC implementation, renamed to
    "testgc", with the symbols `rb_gc_impl_gc_enable` and
    `rb_gc_impl_gc_disable` removed:

    **Before:**

    ```
    λ batify build → 74a4e2e66d → ~/.rubies/modgc/bin/ruby
    ruby_modular_gc_init: rb_gc_impl_gc_enable function not exported by library /Users/prajjwal/.rubies/modgc/lib/ruby/gc/librubygc.testgc.bundle
    ```

    **After:**

    ```
    λ batify build → master → ~/.rubies/modgc/bin/ruby
    ruby_modular_gc_init: rb_gc_impl_gc_enable function not exported by library /Users/prajjwal/.rubies/modgc/lib/ruby/gc/librubygc.testgc.bundle
    ruby_modular_gc_init: rb_gc_impl_gc_disable function not exported by library /Users/prajjwal/.rubies/modgc/lib/ruby/gc/librubygc.testgc.bundle
    ruby_modular_gc_init: found 2 missing exports in library /Users/prajjwal/.rubies/modgc/lib/ruby/gc/librubygc.testgc.bundle
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16161

commit 98269b6d64f26d1e8f22f3d8fddd30393f009e17
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-13 08:40:46 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-13 08:40:46 +0900

    [Feature #21796] unpack variant `^` that returns the final offset (#15647)

    [Feature #21796] unpack variant `^` that returns the current offset

  Notes:
    Merged-By: tenderlove <aaron.patterson@gmail.com>

commit f0ff0df584b75b2588952e516d16ff8f134f9832
  Author:     Samuel Williams <samuel.williams@oriontransfer.co.nz>
  AuthorDate: 2026-02-13 08:21:59 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-13 08:21:59 +0900

    Introduce suport for `autoload_relative`. (#16148)

  Notes:
    Merged-By: ioquatix <samuel@codeotaku.com>

commit c61f52a012f0a390a869db4825143187ea468d21
  Author:     Aaron Patterson <tenderlove@ruby-lang.org>
  AuthorDate: 2026-02-13 08:11:39 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-13 08:11:39 +0900

    [Feature #21785] Add LEB128 again (#16123)

    * Revert "Revert pack/unpack support for LEB128"

    This reverts commit 77c3a9e447ec477be39e00072e1ce3348d0f4533.

    * Update specs for LEB128

  Notes:
    Merged-By: tenderlove <aaron.patterson@gmail.com>

commit d8b8a95af9d6aab1e8da2b6f1808bc3ffd406889
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-13 14:35:58 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-13 04:35:18 +0900

    Make Monitor a core class

    [Feature #21788]

    It allows monitor to access internal routines and remove some overhead.

    Before:

    ```
    ruby 4.0.0dev (2025-12-13T04:52:13Z master 71dd272506) +YJIT +PRISM [arm64-darwin25]
    Warming up --------------------------------------
                   Mutex     2.111M i/100ms
                 Monitor     1.736M i/100ms
    Calculating -------------------------------------
                   Mutex     25.050M (± 0.4%) i/s   (39.92 ns/i) -    126.631M in   5.055208s
                 Monitor     19.809M (± 0.1%) i/s   (50.48 ns/i) -    100.672M in   5.082015s
    ```

    After:

    ```
    ruby 4.0.0dev (2025-12-13T06:49:18Z core-monitor 6fabf389fd) +YJIT +PRISM [arm64-darwin25]
    Warming up --------------------------------------
                   Mutex     2.144M i/100ms
                 Monitor     1.859M i/100ms
    Calculating -------------------------------------
                   Mutex     24.771M (± 0.4%) i/s   (40.37 ns/i) -    124.342M in   5.019716s
                 Monitor     23.722M (± 0.4%) i/s   (42.15 ns/i) -    118.998M in   5.016361s
    ```

    Bench:

    ```ruby
    require 'bundler/inline'

    gemfile do
      gem "benchmark-ips"
    end

    mutex = Mutex.new
    require "monitor"
    monitor = Monitor.new

    Benchmark.ips do |x|
      x.report("Mutex") { mutex.synchronize { } }
      x.report("Monitor") { monitor.synchronize { } }
    end
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15538

commit f33073a6cb8e6800309de815a1acce3322401bd1
  Author:     Anthony Panozzo <panozzaj@gmail.com>
  AuthorDate: 2026-01-18 05:19:58 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 02:06:39 +0900

    [ruby/rubygems] Fix Gem.clear_paths to reset cache_home and data_home

    These memoized instance variables were not being cleared, causing
    test isolation issues when HOME environment variable changes.

    https://github.com/ruby/rubygems/commit/a8b3e0bca0

commit 104c8be99cac15810456577ca14f9c2887c1c5d7
  Author:     Anthony Panozzo <panozzaj@gmail.com>
  AuthorDate: 2026-01-08 03:04:57 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 02:06:38 +0900

    [ruby/rubygems] Fix global_cache_spec to work with system RubyGems

    When running Bundler tests against system RubyGems (which doesn't have
    Gem.global_gem_cache_path), the test needs to use the fallback cache
    location (~/.bundle/cache/gems/) that Bundler uses in that case.

    https://github.com/ruby/rubygems/commit/a6fc1d862b

commit e59dd8fe0536e630ab0fb053212f80b34c2d3099
  Author:     Anthony Panozzo <panozzaj@gmail.com>
  AuthorDate: 2026-01-07 00:47:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 02:06:38 +0900

    [ruby/rubygems] Update global cache test to use XDG cache path

    The global gem cache is now at ~/.cache/gem/gems/ (XDG standard)
    instead of ~/.bundle/cache/gems/ to align with the shared
    RubyGems/Bundler cache implementation.

    https://github.com/ruby/rubygems/commit/8f845a72e7

commit a55874406cb1be41073c6353052bb88d44123217
  Author:     Anthony Panozzo <panozzaj@gmail.com>
  AuthorDate: 2026-01-06 03:04:14 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 02:06:37 +0900

    [ruby/rubygems] Add backwards compatibility for Bundler with older RubyGems

    Guard against missing Gem.global_gem_cache_path method when
    Bundler is used with an older RubyGems version that doesn't
    have the global cache feature. Falls back to the previous
    Bundler.user_cache location.

    Suggested by skipkayhil.

    https://github.com/ruby/rubygems/commit/a4bb3a20f8

commit 2475f67c575b74d733929aa72e779a1f923d187b
  Author:     Anthony Panozzo <panozzaj@gmail.com>
  AuthorDate: 2026-01-06 03:03:54 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 02:06:36 +0900

    [ruby/rubygems] Simplify global cache integration in RemoteFetcher#download

    Instead of checking global cache separately and copying after download,
    integrate global_gem_cache as the first option in cache_dir selection.
    This removes ~20 lines while achieving the same behavior.

    Suggested by Aaron Patterson.

    https://github.com/ruby/rubygems/commit/48ce0ecc32

commit 2101c1bf091c30379daf96d4426a59e84002cccf
  Author:     Anthony Panozzo <panozzaj@gmail.com>
  AuthorDate: 2026-01-02 09:21:42 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 02:06:36 +0900

    [ruby/rubygems] Add global gem cache shared by RubyGems and Bundler

    Add opt-in support for a global .gem file cache at ~/.cache/gem/gems
    (respects XDG_CACHE_HOME). This allows sharing cached gems across all
    Ruby installations and between RubyGems and Bundler.

    Enable via:
    - Environment: RUBYGEMS_GLOBAL_GEM_CACHE=true
    - gemrc: global_gem_cache: true
    - Bundler: bundle config set global_gem_cache true

    When enabled, RubyGems checks the global cache before downloading and
    copies downloaded gems to the cache. Bundler's existing global_gem_cache
    setting now uses the same unified cache location.

    https://github.com/ruby/rubygems/commit/417e10d6a1

commit fd9dd36dfc38fd818dba0558bacb7c2df9bcdb79
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-13 00:40:54 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-13 00:53:47 +0900

    [ruby/prism] Revert "Fix lexing for unterminated strings/heredocs etc."

    This reverts commit https://github.com/ruby/prism/commit/8f35e8ef255b.

    https://github.com/ruby/prism/commit/ed48f6dbfb

commit b5d2c6eeca28f4c640389b006896a8f3f59e7571
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-12 23:12:48 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 23:52:57 +0900

    [ruby/json] Remove bignum warnings

    test/json/json_parser_test.rb:141: warning: Integer out of Float range
    lib/json/common.rb:353: warning: Float https://github.com/ruby/json/commit/123456789012... out of range

    https://github.com/ruby/json/commit/e7245b714a

commit 23ca981ea28ade997fadef8d0e9acf6aa52c60b5
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-12 21:39:07 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 23:52:57 +0900

    [ruby/json] Remove unused method in JSONGeneratorTest

    https://github.com/ruby/json/commit/9602edb255

commit 3b5ee7488c8064cd3b1afc41bc43afdb907fdf16
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2025-12-20 21:48:10 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-12 23:52:42 +0900

    Dir.scan: return or yield children along with their type

    [Feature #21800]

    There are numerous ruby tools that need to recursively scan
    the project directory, such as Zeitwerk, rubocop, etc.

    All of them end up listing childs of a directory then for each child
    emit a `stat` call to check if it's a directory or not.

    This is common enough for a pattern that on most operating
    systems, `struct dirent` include a `dtype` member that allows to
    check the file type without issuing a any extra system calls.

    By yielding that type, we can make these routines twice as fast.

    ```
    $ hyperfine './miniruby --disable-all --yjit ../test.rb' 'OPT=1 ./miniruby --disable-all --yjit ../test.rb'
    Benchmark 1: ./miniruby --disable-all --yjit ../test.rb
      Time (mean ± σ):      1.428 s ±  0.062 s    [User: 0.342 s, System: 1.070 s]
      Range (min … max):    1.396 s …  1.601 s    10 runs

    Benchmark 2: OPT=1 ./miniruby --disable-all --yjit ../test.rb
      Time (mean ± σ):     673.8 ms ±   5.8 ms    [User: 146.0 ms, System: 527.3 ms]
      Range (min … max):   659.7 ms … 679.6 ms    10 runs

    Summary
      OPT=1 ./miniruby --disable-all --yjit ../test.rb ran
        2.12 ± 0.09 times faster than ./miniruby --disable-all --yjit ../test.rb
    ```

    ```ruby
    if ENV['OPT']
      def count_ruby_files
        count = 0
        queue = [File.expand_path(__dir__)]
        while dir = queue.pop
          Dir.scan(dir) do |name, type|
            next if name.start_with?(".")

            case type
            when :directory
              queue << File.join(dir, name)
            when :file
              count += 1 if name.end_with?(".rb")
            end
          end
        end
        count
      end
    else
      def count_ruby_files
        count = 0
        queue = [File.expand_path(__dir__)]
        while dir = queue.pop
          Dir.each_child(dir) do |name|
            next if name.start_with?(".")

            abspath = File.join(dir, name)
            if File.directory?(abspath)
              queue << abspath
            else
              count += 1 if name.end_with?(".rb")
            end
          end
        end
        count
      end
    end

    10.times do
      count_ruby_files
    end
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16153

commit e26bef571c3c916826fdd2f468dea7ca41369f8e
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-12 01:01:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 23:51:03 +0900

    [ruby/prism] Skip missing heredoc end in ripper translator

    Prism inserts these to make bookkeeping easier. Ripper does not do so.

    https://github.com/ruby/prism/commit/0a3b560218

commit ed113c556bb2bba97fa57f81f01400ccaf24473a
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-11 21:03:49 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 23:51:03 +0900

    [ruby/prism] Fix lexing for unterminated strings/heredocs etc.

    When we hit EOF and still have lex modes left, it means some content was unterminated.
    Heredocs specifically have logic that needs to happen when the body finished lexing.
    If we don't reset the mode back to how it was before, it will not continue lexing at the correct place.

    https://github.com/ruby/prism/commit/8f35e8ef25

commit dca8d9a6aa9c590a5707959d2c211a8273f7bc06
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-12 22:46:02 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-12 23:47:37 +0900

    Fix prism docs

    Ruby codes lives in lib/prism but c code is just in prism.
    This fixes docs on https://docs.ruby-lang.org/en/master/Prism.html

    Currently it doesn't list any methods that are defined in the C extension

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16146

commit 727b99f9c5dca7ee8d6529171d3e0754855f5fb7
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-02-12 20:06:32 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-12 23:26:16 +0900

    Avoid loading source cgi/escape.rb with baseruby in enc/make_encmake.rb

    Only add the source lib directory to $LOAD_PATH when running with
    miniruby, which needs it for the standard library (erb, fileutils,
    etc.). When running with baseruby (detected via CROSS_COMPILING
    defined by fake.rb), its own stdlib is already available and adding
    the source lib causes warnings with -w due to loading both
    baseruby's cgi/escape.so and the source cgi/escape.rb via erb.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16158

commit c251767fbeacc95963a1c68feed976e8d492d3fc
  Author:     Matt Valentine-House <matt@eightbitraptor.com>
  AuthorDate: 2026-01-23 08:01:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 21:51:50 +0900

    [ruby/mmtk] Implement rb_gc_impl_during_gc_p

    https://github.com/ruby/mmtk/commit/039fa648fe

commit 70cf85af9915b0a1d3e7ab3459e9e7ab685e4de1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-12 20:30:12 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-12 21:07:22 +0900

    Use Oregon mirror for cygwin download

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16157

commit c46fe31138d2a76c6121c444135f5cb97e782ec7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-06 14:42:29 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-12 19:20:50 +0900

    [Bug #21862] Extract -D/-U options only for dtrace

    A workaround for GH-12563#issuecomment-3691590489.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16156

commit 2d159fbbb6e3a123654a6a60b12654eedfcefd9d
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-12 18:31:00 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-12 19:17:44 +0900

    Use EXIT_SUCCESS/EXIT_FAILURE instead of 0/1

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16155

commit b698c35590671e2b6f5920ca01c83ec4ebea610b
  Author:     Chris Hasiński <krzysztof.hasinski@gmail.com>
  AuthorDate: 2026-01-20 02:35:52 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-12 18:10:02 +0900

    Fix bundled gems warning for all subfeatures of hyphenated gems

    PR #15822 fixed the warning for direct hyphenated gem requires like
    `benchmark/ips` → `benchmark-ips`. However, hyphenated gems often
    provide multiple files under their namespace.

    For example, `benchmark-ips` provides:
    - benchmark/ips.rb
    - benchmark/timing.rb
    - benchmark/compare.rb

    When requiring `benchmark/timing`, the previous fix only checked for
    `benchmark-timing` gem (doesn't exist), not `benchmark-ips` which
    actually provides the file.

    This fix checks if ANY gem matching `{prefix}-*` is in the bundle
    specs, which covers all subfeatures provided by hyphenated gems.

    Reported in https://github.com/ruby/ruby/pull/15822#issuecomment-123456

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15908

commit d57b75297391af5b5d4f279eeeec084df37e9618
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-12 17:23:13 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 17:38:43 +0900

    [ruby/prism] Run ruby_parser versions for ruby 3.3

    It will not support newer ruby versions:
    https://github.com/seattlerb/ruby_parser?tab=readme-ov-file#notice

    This way we don't have to exclude new syntax.

    https://github.com/ruby/prism/commit/2ffb629d4e

commit 8f7c12830f431a92582a1a7831dee248820b27d9
  Author:     Nery Campusano <nery.campusano@shopify.com>
  AuthorDate: 2026-02-12 06:07:49 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 12:11:10 +0900

    [ruby/prettyprint] [Bug #21874] pretty print single line compatibility

    https://github.com/ruby/prettyprint/commit/b02076cc9c

commit a2a818169d7f1e47699af6a18603afafbdade4be
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-12 10:01:18 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-12 10:01:18 +0900

    [DOC] Stop expanding GitHub style references in ChangeLog

    For conciseness, omit URL expansion within ChangeLog files. Instead,
    RDoc now handles external commit references when converting ChangeLog
    to HTML.
    C.f., ruby/rdoc#1547.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16151

commit 9aa30b512f12ac3e298f7b971cdbd0e2cae8fc68
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-12 06:30:26 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-12 07:01:30 +0900

    Revert "Fix check in cc_is_active"

    This reverts commit 9d8af87528be09bd4f846592e4922228288e3a10.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16147

commit b746efc1fb46074ae659b4af0f9114aae9540e41
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-12 06:30:26 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-12 07:01:30 +0900

    Revert "Simplify iseq mark_and_move CC handling"

    This reverts commit b657d906ad0d38b2015955b69f5711588801bc7a.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16147

commit b657d906ad0d38b2015955b69f5711588801bc7a
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-11 06:08:39 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-12 02:00:47 +0900

    Simplify iseq mark_and_move CC handling

    We should special-case the empty CC cases in the parent, since we
    already had to check for that to avoid unnecessary writes hurting
    copy-on-write.

    This also changes reference updating to only update the CC reference
    rather than also checking for the CC being active. There's less
    advantage to removing a reference in that phase as the object still
    can't be freed until the next time mark is run, so we might as well just
    wait.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16140

commit 9d8af87528be09bd4f846592e4922228288e3a10
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-11 05:33:51 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-12 02:00:47 +0900

    Fix check in cc_is_active

    rb_vm_empty_cc_for_super() is always true, so this previously always
    returned false.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16140

commit 0c9bd7fd5cfd242fcc550bfc27644d1fc07793de
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-12 00:31:21 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-12 00:44:49 +0900

    [DOC] Fix a broken link YJIT

    Fix up GH-16119.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16145

commit b9203a93834aed48c9fddf31616b9146041f3465
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-07 02:38:32 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-12 00:40:48 +0900

    Remove prism pack parsing

    It was never adopted by ruby or other implementations.
    Ruby 4.1 may add new directives, so now is a good time to remove it.

    It was actually never properly documented (just shows `Prism::Pack` with no methods)
    so removing seems safe to do even now.

    Ref
    * https://github.com/ruby/prism/pull/3909
    * https://github.com/ruby/prism/issues/3907

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16085

commit 59bfa2b5102440ddc7bbcfa94f76024a7ce2e66b
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-12 00:19:27 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-12 00:39:33 +0900

    [ruby/stringio] Use raw FL macros over using RBASIC directly

    https://github.com/ruby/stringio/commit/d6dd409b74

commit 74a4e2e66d14fed7d6ade09345a54ed14bc106cc
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-11 22:09:26 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-11 22:09:26 +0900

    [Bug #21851] Divide as double if accurate

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16144

commit e7f1746d55b1e4783012006c13d71c4d067fce00
  Author:     Jeremy Evans <code@jeremyevans.net>
  AuthorDate: 2026-02-11 00:11:09 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2026-02-11 21:42:44 +0900

    [DOC] Update documentation for RB_{SCAN_ARGS,PASS}_KEYWORDS

    When using RB_SCAN_ARGS_KEYWORDS or RB_PASS_KEYWORDS, the final
    argument must be a hash.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16133

commit 30b1e5254301bf6dc935c530242161ff12950abd
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-11 02:28:18 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-11 18:47:30 +0900

    [ruby/prism] Remove unneeded exit conditions for `parse_stream`

    As I understand it, the code operates line-by-line. When finding `__END__`, it has to decide if it is
    the end marker or just appears as part of of a multi-line literal (see tests).

    For a future PR I plan to make, `lex_modes` may be empty after parsing finished, even if it was syntax invalid.
    Currently there will _always_ be errors when lex modes are not popped. So these extra checks are redundant.

    Basically, if we found `__END__` on a line by itself and there are syntax errors, it's impossible to be the end marker.

    https://github.com/ruby/prism/commit/8b63780a9d

commit f38ebb911e93e2bcba7a789ac5136327886d037b
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 07:50:14 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-11 15:03:57 +0900

    [ruby/delegate] No need for placeholder with leading underscore

    https://github.com/ruby/delegate/commit/39d2c9aa00

    Co-authored-by: Jean Boussier <jean.boussier@gmail.com>

commit 98474967b9c858ae2de9d6371303cddef167c6df
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2025-12-19 04:39:22 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-11 15:03:57 +0900

    [ruby/delegate] Use alias_method for invalid names

    This allows using the same code for both "specially named" and regular
    methods. This uses :__delegate as the name, which may be visible to
    users in backtraces for these methods.

    https://github.com/ruby/delegate/commit/82125cd687

    Co-authored-by: Luke Gruber <luke.gruber@shopify.com>

commit c272297e8a9f2b8034739b915707910b4e568479
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-11 03:47:52 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-11 03:47:52 +0900

    ZJIT: Use worklist algorithm for type inference (#16122)

    ## Summary
    - Replace the RPO fixed-point iteration in `infer_types` with a worklist-based approach
    - Instead of re-scanning every reachable block on each iteration, only re-process blocks whose incoming types actually changed
    - Add `BitSet::remove` helper for worklist membership tracking

    ## Benchmark
    On lobsters (release+stats build, 10 iterations):

    | Stat | Branch | Master | Delta |
    |------|--------|--------|-------|
    | compile_time | 1,604ms | 1,808ms | -204ms (-11.3%) |
    | Avg iter time | 766ms | 807ms | -41ms (-5.1%) |

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 09ae95332f34791c68c841f8ad41b3f3ff9e8609
  Author:     Randy Stauner <randy@r4s6.net>
  AuthorDate: 2026-02-11 02:48:17 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-11 02:48:17 +0900

    ZJIT: Avoid runtime exceptions from RubyVM::ZJIT.stats_string (#16134)

    Before this it would raise if zjit wasn't enabled
    and raise a different exception if zjit was but extended stats were
    not (_some_ stats are available).

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit acacbec35943a1fd3dd58af54d78fb878d80aae4
  Author:     Takashi Kokubun <takashikkbn@gmail.com>
  AuthorDate: 2026-02-11 02:32:37 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-11 02:32:37 +0900

    ZJIT: Move JIT code tests from test_zjit.rb to Rust (#16130)

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 1a3ba1b6dd202ffe27d5adfc63e767684b559921
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2026-02-11 00:18:50 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2026-02-11 00:51:04 +0900

    Use a ruby_bug guard since this bug fix will likely be backported

    * And it should be tested on current versions of other Ruby implementations.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16132

commit 49f44b1ddd0c0da2cb734d91a441c3bbaf11ecf0
  Author:     Mike Dalessio <mike@37signals.com>
  AuthorDate: 2026-02-10 23:21:22 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2026-02-11 00:51:04 +0900

    Add ruby specs for UnboundMethod#== with included/extended modules [Bug #21873]

    https://bugs.ruby-lang.org/issues/21873

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16132

commit f486ee340289b779654fe2d6c1de5a348fd76d86
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-10 08:17:06 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-10 20:07:47 +0900

    [Feature #21872] Search script from $PATH only if no separator

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16131

commit 1ea75b711f9c64e32b9bc21047a5c1ce6ac0b9ae
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2026-02-10 16:09:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-10 16:09:10 +0900

    Update bundled gems list as of 2026-02-09

commit 2967f98f305b95e7c910facd2d9b3381bd0296a8
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-10 12:50:33 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-10 12:50:33 +0900

    Use relative path in dependabot exclude-paths

commit 8f82cbf8ffc3e22b489efa19c006789f90bc0046
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-10 11:51:04 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-10 12:49:05 +0900

    Exclude gc/mmtk in dependabot

    Dependabot runs upstream in the ruby/mmtk repository so it should not be
    ran here.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16126

commit 1fcabc481a14a49167ea7fbed588f87e59c801bb
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-10 11:55:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-10 11:55:35 +0900

    [DOC] Fix links in doc guide

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16115

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 752c88bab3239e9cd52e5a56a55fc10d3a464b82
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-10 11:17:10 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-10 11:21:34 +0900

    [DOC] Fix hash style for Array#flatten

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16125

commit a4b28f14cc9983e90ee5273d83d03d0f2eea7de7
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-10 11:16:20 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-10 11:21:34 +0900

    [DOC] Fix hash style for Array#flatten!

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16125

commit 7c13b21f47d87aae53e415f06b9a778c471318c5
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-10 02:30:09 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-10 11:09:20 +0900

    [DOC] Improve link

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16119

commit f96d106d3a94661a4cc39c0285f78fe84ed2f891
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-10 08:55:32 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 09:28:04 +0900

    Don't use cexpr

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16099

commit 11c845efecc76735110e40d9b05ff5045f1ce925
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-07 11:43:23 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 09:28:04 +0900

    ZJIT: Inline Primitives for Array#each

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16099

commit 98e6f5e4bc56b8b611d152a43500531478a6472d
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-07 07:45:58 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 09:28:04 +0900

    Enable ZJIT jit hooks for with_jit builtins

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16099

commit f96f84837d5dfedaee9758141fd2006ffb03e96d
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-07 07:40:17 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 09:28:04 +0900

    Replace ary_fetch_next with separate array iteration primitives

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16099

commit f43d294d58f96227b33b491fcbd347dd605d3c67
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-07 05:50:56 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 09:28:04 +0900

    Add without_interrupts primitive attribute to skip interrupt checks

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16099

commit 836c1700104c305fa13cbc7b17d114705dd807b2
  Author:     Mike Dalessio <mike@37signals.com>
  AuthorDate: 2026-02-10 03:45:34 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-10 08:26:48 +0900

    Fix UnboundMethod#== for methods from included/extended modules

    Method#unbind clones the method entry, preserving its defined_class.
    For methods mixed in via include/extend, defined_class is an ICLASS,
    causing UnboundMethod#== to return false when comparing against the
    same method obtained via Module#instance_method.

    Resolve ICLASS defined_class in method_eq.

    Fixes [Bug #21873]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16120

commit e0b757f63aa6e720af6200171b2f0841d4efe7ed
  Author:     Nozomi Hijikata <121233810+nozomemein@users.noreply.github.com>
  AuthorDate: 2026-02-10 07:34:59 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-10 07:34:59 +0900

    ZJIT: Compile getconstant insn (#16109)

    * ZJIT: Compile getconstant insn

    * ZJIT: add fixme comments for opt_getconstant_path

    * ZJIT: Address comments

    - Replace fixme with actionable todo comment
    - Fix type validation for GetConstant

  Notes:
    Merged-By: k0kubun <takashikkbn@gmail.com>

commit 9efe557da5e17fc860f40956192e9df2e6bd1e6c
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-10 06:40:25 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-10 06:40:25 +0900

    ZJIT: Drop has_blockiseq guard on local variable access (#16113)

    So `has_blockiseq` was masking two other bugs.

    First, that we had only a static EP escape check for an iseq. We need to check
    both that an iseq is not known to statically escape them *and that it has not
    escaped them before*. Only then can we use SSA locals. This popped up in a
    weird PP unit test that was reducible to the test cases added in the PR. So I
    fixed that.

    Second, that we didn't VM lock when code patching for EP escape. That showed up
    in the Ractor btests in my previous PRs #14600 and #15254 #15316, and I had no
    idea what was going on at the time, so I dropped it. But if we add this lock,
    like all the other invariant patching cases have, the problem goes away. Seems
    reasonable.

    Finally, we can use normal full SSA locals even in the presence of a blockiseq.
    We still reload all of them after each send-with-block, but we can in a later
    PR reduce that to just the locals that are (recursively) visibly written to.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 51d4c2c465e3ce708dddcd65d93e6e29225b454d
  Author:     Xavier Noria <fxn@hashref.com>
  AuthorDate: 2026-02-09 21:46:05 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-10 06:32:50 +0900

    [ruby/rubygems] Document gemspecs must be deterministic

    https://github.com/ruby/rubygems/commit/7cab5cd68f

commit 3d00e34ab1d533820d2cd8bc361549b336767c9c
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-06 03:53:08 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 03:23:36 +0900

    ZJIT: Check for size >= expected in expandarray

    Turns out `a, b = [1, 2, 3, 4]` is perfectly valid and just assigns `a =
    1` and `b = 2` (and drops the rest). optcarrot relies on this. Allow it.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16079

commit be54efb40378314cf74515cfefcf3c318fdd0e5a
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-06 03:52:15 +0900
  Commit:     Max Bernstein <tekknolagi@gmail.com>
  CommitDate: 2026-02-10 03:23:36 +0900

    ZJIT: Add reason to GuardGreaterEq

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16079

commit 4d13aeb3caedbecab58e24c601ab8c907fac9800
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-10 02:52:35 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-10 02:52:35 +0900

    ZJIT: Make defined?(yield) in non-method local iseq emit const nil (#16063)

    No sense doing this in codegen; we can pull this up to the HIR level.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 21862be0afdd76d80875b4f98ce104113090c0c3
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-10 02:40:27 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-10 02:40:27 +0900

    ZJIT: Add mask_name to GuardXYZBitsSet (#16064)

    This makes HIR easier to debug.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 84c9822fefa442ef2fff174437a8bd723c8c658b
  Author:     Max Bernstein <ruby@bernsteinbear.com>
  AuthorDate: 2026-02-10 00:16:03 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-10 00:48:19 +0900

    Update disassembly snapshots for capstone 0.14.0

    Capstone 0.14.0 uses canonical ARM64 aliases in its disassembly output:
    - `orr x, xzr, #imm` is now shown as `mov x, #imm`
    - `.byte` sequences matching `udf` are now decoded as `udf #imm`

    These are cosmetic changes to the disassembly text only; the underlying
    machine code (verified by hex snapshots) is unchanged.

    Also update the root Cargo.lock which was missed by Dependabot.

    Co-Authored-By: Claude Opus 4.6 (1M context) <noreply@anthropic.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16073

commit cb37ef5b2adb01dfa1609df6b962ba798ca9ad72
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-10 00:36:18 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-10 00:36:51 +0900

    [ruby/prism] Improve node docs
    (https://github.com/ruby/prism/pull/3912)

    Currently I find them hard to follow because there are just so many methods.

    This groups them by topic instead so that the more unique methods appear first.
    I also added call-seqs because we have the type information, so why not.

    https://github.com/ruby/prism/commit/caf018ec50

commit 930b94640db86b781f26b9c9c9549a4ed7173c80
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-09 14:15:37 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-09 16:32:07 +0900

    Update clang for LTO

commit 35cb1fed58101b8917e99eaa9371ed1d32f219af
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-09 15:48:29 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-09 16:24:39 +0900

    Added clang-23

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16117

commit 1b342ad9b89a425b16102e81667256c2c2bff258
  Author:     eileencodes <eileencodes@gmail.com>
  AuthorDate: 2025-11-18 06:38:46 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-09 14:49:09 +0900

    [ruby/rubygems] Remove `verify_gz`

    This PR removes the `#verify_gz` method because it is redunant and
    unnecessary.

    Previously the `data.tar.gz` would get read twice for every file - once
    in `verify_gz` and once in `extract_files`. The `extract_files` method
    verifies the `data.tar.gz` when it reads it, and raises an error if
    unzipping it fails.

    The `verify_gz` code can be seen in some profiles as a hotspot -
    although not major - as it accounts for between 9% and 17% of time, but
    only when the installation thread doesn't have native extensions or
    plugins.

    https://github.com/ruby/rubygems/commit/737c82986c

commit 510ebbdf6e59db83337da66b62201816707db374
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 03:06:34 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-09 09:09:04 +0900

    [ruby/rubygems] [DOC] Fix link in Bundler

    https://github.com/ruby/rubygems/commit/81af6f4e85

commit ddcf400fb5847e3305db6db91b2ff9c3f89c9192
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-06 18:05:26 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-09 09:08:11 +0900

    [ruby/rubygems] Do not create unnecessary directories

    The method `Spec::Path#vendored_gems` creates the directory containing
    the path.  It makes no sense to create a directory with the same name
    as its basename in the current working directory.

    https://github.com/ruby/rubygems/commit/725f4ff2f4

commit 696087d1ef12ad23adef34a03b6f3dc6122d80b5
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-06 17:56:30 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-09 09:08:11 +0900

    [ruby/rubygems] Revert "Cleaned up bundler .gem and .gemspec files in ensure block."

    This reverts commit https://github.com/ruby/rubygems/commit/dce4ef87bb70.

    https://github.com/ruby/rubygems/commit/3b62e468c3

commit 0069009d35cf6b9ed78cf4fb5e5ce46dae21080f
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-08 12:24:27 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-09 00:28:52 +0900

    Exclude test for MMTk

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16111

commit 40117ea04b7b5ff5a41f4d5ad4159692eca93bdd
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-08 11:49:23 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-09 00:28:52 +0900

    Use Object for ObjectSpace.dump test

    This test fails if BASE_SLOT_SIZE is 32 bytes because Strings occupy 40
    bytes. Objects are smaller and would be 40 bytes.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16111

commit cbf6e775ee180cc4db49289f0db774d489fb9a4c
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-07 18:30:35 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-08 20:47:40 +0900

    darray.h: use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16100

commit 3e02e99e425ee1c2e4a7cee625eaea6ed1faf1c4
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-08 01:44:08 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-08 15:15:37 +0900

    Fix signal crash during keyword argument call

    64f508ade8 changed rb_threadptr_raise to call rb_exception_setup,
    which uses rb_scan_args with RB_SCAN_ARGS_PASS_CALLED_KEYWORDS.
    This checked rb_keyword_given_p(), which read the interrupted
    frame's keyword state rather than the signal raise arguments,
    causing a crash when a signal arrived during a keyword call.

    Revert rb_threadptr_raise to use rb_make_exception directly, and
    have thread_raise_m call rb_exception_setup where
    rb_keyword_given_p() reflects the correct frame.

    [Bug #21865]

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16103

commit bdb3b8640644aa11772e9f76307e4d35b1500f39
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-08 10:04:51 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-08 11:45:05 +0900

    Remove reserved field in imemo memo

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16107

commit fd089e3e95ebbded14c9a2d51fce376fbbbf289d
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-08 10:50:54 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-08 11:20:17 +0900

    Revert "Wake timer to create new SNT when needed for dedicated task (#16009)"

    This reverts commit 7b3370a5579956404d742a2e104d72e7c89480e4.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16110

commit d5af159556b63c97ee35199dd7c70b5127e58cb3
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-08 04:38:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-08 04:44:23 +0900

    [ruby/json] [DOC] Another link fix

    https://github.com/ruby/json/commit/0bbcf80373

commit 2e398533e14915bb8c650975f784f2693171d39a
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-08 03:46:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-08 04:44:23 +0900

    [ruby/json] [DOC] Fix links

    https://github.com/ruby/json/commit/672e26e3ee

commit 1f0fc3da7090977110d8d64d2ad69bfa3f5cc584
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-06 10:06:42 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-08 01:12:04 +0900

    Remove dead rb_darray_swap_remove

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16081

commit c9cb17fab28419350ca854bec69c74530b20076c
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-07 22:51:02 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-07 22:51:02 +0900

    Omit version check of Unicode headers

    These headers are stored in directories labeled with the current
    Unicode version, so no worry about headers for different versions
    being mixed together.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16102

commit f33076be41394b1ac613b010aaff8c79f7e437f4
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-05 17:37:46 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-07 21:18:25 +0900

    Clean rust target when rustc bumped up

    Fix:
    ```
    error[E0514]: found crate `jit` compiled by an incompatible version of rustc
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16074

commit 51e65c210ed63e3ec8005ab6d5098210b59a158e
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-06 20:20:50 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-07 21:18:25 +0900

    Get rid of repeated building load.o

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16074

commit 73fe5bc142496ec8194f17a41fecf21ef65112e7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-07 19:50:24 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-07 19:52:27 +0900

    [DOC] Use rdoc-ref

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16101

commit 804cb80f431376f87027b30575fb3c23e1c2ae31
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-07 19:49:26 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-07 19:52:27 +0900

    [DOC] Extract repeated references

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16101

commit 9ab9813c721842656b061e47482c228ccfd9b115
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-07 18:58:32 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-07 19:52:27 +0900

    [DOC] Fix the combination of custom option and `-e`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16101

commit cf997380c5909073d6349d20f0658cbc1dff28be
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-07 17:34:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-07 19:52:27 +0900

    [DOC] Fix internal links

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16101

commit a87ff5ff95aa144a751f19a30cb343dca7dddd87
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-07 17:16:32 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-07 19:52:27 +0900

    [DOC] The order of command line options

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16101

commit d066b9e01ccb2260fac8b2580c10e73335c7c7db
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-06 04:38:00 +0900
  Commit:     Benoit Daloze <eregontp@gmail.com>
  CommitDate: 2026-02-07 18:06:36 +0900

    Refactor type error to be more consistent

    [Bug #21864]

    Co-Authored-By:  Benoit Daloze <eregontp@gmail.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16078

commit 96d00640978d78ede1f5b2b63e422cfd1e849891
  Author:     Jacob <jacob.denbeaux@shopify.com>
  AuthorDate: 2026-02-07 12:27:20 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-07 12:27:20 +0900

    ZJIT: Fix graphviz generation (#16053)

    Print to a file and fix a bug.

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit ff55280320efd350432e2862cc52e4d84f893936
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-06 08:31:18 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-07 08:35:59 +0900

    Remove useless reserved field in vm_throw_data

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16080

commit a81e558837208a474ab941b12e697e0e9743e7eb
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 04:55:01 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-07 08:35:46 +0900

    [ruby/stringio] [DOC] Fix links in StringIO

    https://github.com/ruby/stringio/commit/d4b27b8681

commit aff0581e4f122bf0a650b882eff4d7d082f21bc7
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 06:07:59 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-07 08:35:41 +0900

    [DOC] Fix link in Time

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16098

commit f8eed5846926508451fe274dff09137769fa2a35
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 04:39:38 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-07 08:35:02 +0900

    [DOC] Fix links in String

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16095

commit 474dd925832995e959cd87ccdbc1445679162772
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 04:01:45 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-07 08:34:57 +0900

    [ruby/net-http] [DOC] Fix links in module Net

    https://github.com/ruby/net-http/commit/e95d812325

commit 900182e2656bf5a74f26e36c1be1108c6ba0f53d
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-07 08:33:35 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-07 08:34:00 +0900

    [ruby/strscan] [DOC] Fix links
    (https://github.com/ruby/strscan/pull/190)

    https://github.com/ruby/strscan/commit/f6033e5253

commit d79ce7e4e98f3f37e8afe106e739b71601b1a3e8
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-02-07 03:14:56 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-07 08:32:33 +0900

    [ruby/error_highlight] [DOC] Fix link in ErrorHighlight

    https://github.com/ruby/error_highlight/commit/6096a05b2f

commit 954094a910c2dcf459caeb61e20143df0864f914
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2026-02-07 06:08:57 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-07 06:08:57 +0900

    Take VM Lock during rb_gc_{un}register_address (#16097)

    The `Rice` C++ library uses an Anchor class that uses RAII to call
    `rb_gc_register_address`, `rb_gc_unregister_address` during init+destruct.
    It's unclear if this API is meant to be used at runtime like this, but we can
    at least lock the VM so it works safely across Ractors and doesn't mangle the
    `global_object_list` table.

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 7b3370a5579956404d742a2e104d72e7c89480e4
  Author:     Luke Gruber <luke.gruber@shopify.com>
  AuthorDate: 2026-02-07 04:26:07 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-07 04:26:07 +0900

    Wake timer to create new SNT when needed for dedicated task (#16009)

    When removing a thread from `running_threads`, if we're on a shared
    native thread and we're running a dedicated task, we need to wake
    the timer thread so it can create a new SNT if necessary. We only
    do this if it's waiting forever without the 10ms quantum timeout
    for now, because max 10ms of wait is considered "good enough".
    In the future, perhaps we can force the timer thread to wake if this
    becomes an issue (`timer_thread_wakeup_force`).

    Fixes [Bug #21504]

  Notes:
    Merged-By: luke-gru <luke.gru@gmail.com>

commit 130c37d6e60b0b654b93cb09c37b18718e35c0b9
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-07 04:08:46 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-07 04:09:18 +0900

    [ruby/prism] More docs improvements
    (https://github.com/ruby/prism/pull/3910)

    * Update C call seqs

    * Prefixing them with self is unusual
    * Also use `.` instead of `::` to refer to class methods

    * Capitalize location in docs

    It allows it to be linked to in docs

    * Miscelanous other doc tweaks

    * Format code as code
    * Nodoc some missed methods
    * Fix method reference

    * Really try to nodoc ffi module

    The previous approach was wrong, to nodoc the class methods
    it must be specified at the module itself.
    As a result, the private methods like `dump_options` are also removed.

    * Remove some def-style comments

    They are mostly redundant with the method signature and don't look great when rendered.

    Still remaining on nodes. I will improve docs for them in a separate PR

    https://github.com/ruby/prism/commit/94e5525521

commit 545db49ba8063d8e9ed916e508c31523b78d5bb9
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-07 00:41:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-07 00:42:11 +0900

    [ruby/prism] Document fewer useless methods/classes
    (https://github.com/ruby/prism/pull/3908)

    * Add missing nodocs for FFI

    When generating docs in ruby/prism, this doesn't seem to matter.

    But on docs.ruby-lang.org these take over the actual documentation.

    * Nodoc various utility methods

    They don't tell much of a story and just pull attention away from actually unique methods

    * Nodoc some private functions/modules

    * Nodoc translator implementation details

    As well as some functionality from ripper that is nodoc in ruby

    * Stop documenting visitor implementation details

    These result in so many methods that are searchable
    and give no actual benefit.
    Toplevel docs are all you need to understand the usecase.

    https://github.com/ruby/prism/commit/0bd9a7d373

commit c40fbe388a28de6329392f97cdeb82f8a33ef7a0
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 11:06:09 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-06 20:44:20 +0900

    [DOC] Exclude `require` in RubyGems not to override the original

    Fix ruby/rdoc#1592.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16086

commit cda16da6e163c592b7150d2360c7a47f568ef873
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2026-02-04 22:38:06 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-06 20:19:14 +0900

    mswin: improve configure.bat syntax

    Introduce shellsplit.cmd command line parsing subroutine.
    Dealing with the limitations of cmd.exe's command-line parsing forces users to use workarounds, and corner cases still remain.
    By implementing our own command line splitting, we conceal the complexity and ensure maintainability.

    Makefile macro definition and opt-dir list now free from quoting.
    now can use like
    ```
    configure.bat --with-opt-dir=c:/src/zlib;c:/src/libffi CC="cl -std:c11" DEFS=-DOPT_THREADED_CODE=2
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16076

commit d858bed94ed801e788d128fad5e9eb20b6c9f975
  Author:     YO4 <ysno@ac.auone-net.jp>
  AuthorDate: 2026-02-04 23:08:27 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-06 20:19:14 +0900

    mswin: fix configure.bat

    Avoid being affected by the existing environment variable `target`
    Ensure `call set` works correctly even if the external command `set` exists
    Make `--disable-install-doc` work again
    Prevent `--with-static-linked-ext` from consuming subsequent arguments
    Make `--with-opt-dir` work correctly when specifying an existing directory

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16076

commit d9674b155253a3510c1141601a5c557a72fd1f51
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-05 16:31:50 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-06 19:36:56 +0900

    [DOC] Fix -r CLI example

    > <internal:/home/user/.rbenv/versions/4.0.0/lib/ruby/4.0.0/rubygems/core_ext/kernel_require.rb>:139:in 'Kernel#require': cannot load such file -- CSV (LoadError)

    Maybe it currently works on a case-insensitive file system

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16072

commit 6e18331074f188ef79241e3f5155f225da4bd440
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-06 18:03:12 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-06 18:23:16 +0900

    [ruby/json] Stop using RB_ALLOCV

    While it's a very nice API, if the buffer is too big for the
    stack (> 1024B) the buffer object will be mark like a stack region
    which is slow and overkill for a char buffer.

    https://github.com/ruby/json/commit/4dcbcb84a2

commit 17caec3cab53f16ab4e338858560519082e5dd48
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-06 17:33:07 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-06 17:48:29 +0900

    [ruby/json] Cleanup function delecarations

    https://github.com/ruby/json/commit/7ddf3499d0

commit f841f9fc9459d033fa7fb18caaa6e1eb3ac7195d
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-06 16:54:19 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-06 17:30:22 +0900

    [ruby/rubygems] Print message when signing in with an existing API key

    https://github.com/ruby/rubygems/commit/b4a8adbb4d

commit 2d054ef64de31a3306fa9cbaea68cbb5aa0faf21
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-06 16:12:32 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-06 17:15:40 +0900

    [ruby/rubygems] Cleaned up bundler .gem and .gemspec files in ensure block.

    https://github.com/ruby/rubygems/commit/dce4ef87bb

commit fa9e63ada9c5e3ede4cf7eca15de5b5967247df7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 15:07:48 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-06 16:26:30 +0900

    [DOC] Run make for rdoc-coverage and generating html

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16083

commit 08652f825410d0690831151decd2d84ea207f976
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-06 15:33:34 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-06 15:33:34 +0900

    Added instruction to use 'gem "cgi"' or Bundler

commit 26b81bed5050a1ed072cb6a6b10f0369bcdc8cf1
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-06 11:03:52 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-06 11:03:52 +0900

    Extend timeout for ci.rvm.jp

commit 728001caaef3435ffae184d84647bd7f29f0d4d9
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-05 20:40:10 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-06 07:19:59 +0900

    Set Gem::BUNDLED_GEMS::LIBDIR from Spec::Path realpath with symlink at macOS

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16075

commit 86dba8cfaeabb3b86df921da24b3243b9ce4ab2a
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-05 17:53:48 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-05 17:53:48 +0900

    Consolidate Dependabot github-actions updates

commit 9d374b93654f7daddea6a8e96d10e5fff9dbe112
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-05 17:06:02 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-05 17:08:14 +0900

    Monitor yjit and zjit cargo directories and group them as JIT group

commit b8a4d2d722041af5d2abef073ff38cfbe984f36c
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-05 16:29:14 +0900
  Commit:     Sutou Kouhei <kou@clear-code.com>
  CommitDate: 2026-02-05 16:41:36 +0900

    [DOC] Remove remaining csv docs

    csv is not kept in ruby/ruby anymore

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16071

commit eca5e5c59d474e0b5f0515885125ff874aa2b520
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-05 11:17:52 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-05 13:12:24 +0900

    Bypass the conversion of drive letter in `with_destdir`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16051

commit 103517d97e8267985304ca66c7630c424a69f1e3
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-04 17:47:13 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-05 11:59:11 +0900

    Ensure the jobserver is usable

    If invalid, clear jobserver options from the environment variables.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16051

commit 8b46c20e740b5ebdf7aa7aaa6ca8ed11d6bb5568
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 15:27:57 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-05 11:26:39 +0900

    Split RBCONFIG recipe

    And make `ifchange` a pipeline; it works even on Windows now.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16051

commit ad0ac0ec2fd9bbbe1fc69cb9609a56571ca6d63f
  Author:     tompng <tomoyapenguin@gmail.com>
  AuthorDate: 2026-02-04 21:25:12 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-05 10:59:53 +0900

    [ruby/rubygems] Remove "##" from a comment to require

    In RDoc, comment that starts with "##" is a metaprogramming method definition.
    If it's not a metaprogramming method definition, "##" shouldn't be used.

    https://github.com/ruby/rubygems/commit/b1953a3a09

commit 10b6d543f98fc64b41eab9aceae57b498b093771
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-05 09:51:35 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-05 09:55:23 +0900

    [DOC] Fix hash style in Array#to_h

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16070

commit bc849a185a96c032448fed787034eb4503c0cc10
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-05 07:12:24 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-05 07:12:24 +0900

    [DOC] Fix links in Regexp (#16018)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 48d2c7fd62342ec4f1d3b66768a537aea0968eda
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-05 07:08:08 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-05 07:08:08 +0900

    [DOC] Harmonize certain Module methods (#15804)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 9167262940804951127b74aa3012c577a9b8ae09
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-05 03:04:01 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-05 03:04:01 +0900

    ZJIT: Upgrade self to HeapBasicObject after setinstancevariable (#16065)

    If self is an immediate, setinstancevariable would have raised.
    Therefore we can conclude that self must not be an immediate. This helps
    us match YJIT type upgrades (YJIT will upgrade to UnknownHeap or
    something similar).

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 5571212fd363437b70772facf0c1d2281dc9a46a
  Author:     Max Bernstein <rubybugs@bernsteinbear.com>
  AuthorDate: 2026-02-05 00:42:26 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-05 00:42:26 +0900

    ZJIT: Remove specialized instructions (#16034)

    * ZJIT: Fix codegen for GuardSuperMethodEntry

    We need to register the VALUE in the generated code so that it is
    visible to the GC. This may be the cause of a crash in the test suite
    that Alan found.

    * ZJIT: Use LoadField+GuardBitEquals instead of GuardSuperMethodEntry

    We have modular instructions. Use them.

    * ZJIT: Use LoadField instead of GetBlockHandler

    We have modular instructions. Use them.

    * ZJIT: Remove unused HIR instructions

    We don't use GuardSuperMethodEntry, GuardShape, or GetBlockHandler
    anymore.

    * ZJIT: Replace GuardNotFrozen with LoadField+GuardNoBitsSet

    * ZJIT: Replace GuardNotShared with LoadField+GuardNoBitsSet

    * ZJIT: Remove unused HIR instructions

    * ZJIT: Remove comment

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 540ea720e8fbe730d4b6afb68cefe6fb2cf7848e
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-04 22:52:44 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-05 00:00:07 +0900

    Add myself as a prism maintainer

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16062

commit 673c37d76ac2767b13a1ab7ba74b0ea8cda17c81
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-04 22:31:32 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 23:58:08 +0900

    [ruby/prism] Rewrite "version: nearest" to require no maintenance

    Currently I see myself not updating this when a new version is added.

    Instead, rewrite it to just work with new versions:
    * Try to set the version
    * If that doesn't succeed, check if it is lower
    * If it isn't lower, it must be higher

    We can then use `PM_OPTIONS_VERSION_LATEST` which doesn't need to change.

    Also added a very basic test.

    https://github.com/ruby/prism/commit/443e9b9959

commit 1258992bdff8818d3ce868e98ccc3496069d996d
  Author:     Giovanni Tirloni <gtirloni@tirloni.net>
  AuthorDate: 2026-01-28 03:04:30 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 18:50:27 +0900

    [ruby/rubygems] Fix gzip cache corruption when recovering from HTTP 416 responses

    When a Range request returns 416 (Range Not Satisfiable), the recovery
    path manually added an "Accept-Encoding: gzip" header before retrying.
    This bypasses Ruby's automatic gzip decompression mechanism.

    Ruby's Net::HTTP only sets decode_content=true (enabling automatic
    decompression) when Accept-Encoding is NOT present in the request
    headers. By manually setting this header, the decode_content flag
    remained false, causing gzip-compressed response bodies to be written
    directly to the compact index cache without decompression.

    This resulted in "ArgumentError: invalid byte sequence in UTF-8" errors
    when the corrupted cache was later read and parsed as text.

    The fix removes the explicit Accept-Encoding header, allowing Ruby's
    Net::HTTP to handle gzip compression transparently (as it does for all
    other requests). Ruby will still add Accept-Encoding: gzip automatically
    AND properly set decode_content=true for automatic decompression.

    Fixes https://github.com/ruby/rubygems/pull/9271

    https://github.com/ruby/rubygems/commit/b48b090e38

commit 9cc2242ee269fcb4d1fd10887a8270c59eb161fc
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-04 16:38:36 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 18:22:35 +0900

    [ruby/rubygems] bin/rake man:build

    https://github.com/ruby/rubygems/commit/5e95eba208

commit 395ad09c826db156a79bb763f16215bed68d1b7e
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-04 16:15:29 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 18:22:34 +0900

    [ruby/rubygems] Clarify local gem override docs to require git-sourced gems

    https://github.com/ruby/rubygems/commit/a4a5cdb12c

commit c3b6f2e9a2575ea5be0c49fb77ae051fe7981789
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-04 16:32:55 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 16:32:55 +0900

    Load `rubygems/platform.rb` after setting up the load path

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16059

commit 444a3609a5d6ad44e6a0289110384d7716e42115
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 19:12:48 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 16:28:22 +0900

    Fix the load path in building extensions and encodings

    Add `tool/lib` under the source directory instead of the source
    directory itself, as there is no library to be loaded.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16059

commit 03a17facfdd8c2bbcca5862fa98f51e9979b77ca
  Author:     copilot-swe-agent[bot] <198982749+Copilot@users.noreply.github.com>
  AuthorDate: 2026-02-04 11:50:52 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 15:02:24 +0900

    [ruby/rubygems] Add test case for git sources with transitive dependencies

    https://github.com/ruby/rubygems/commit/00c8bb7bc5

    Co-authored-by: hsbt <12301+hsbt@users.noreply.github.com>

commit 0c2ded4a07e0ba0e4d2d9ab92d549135300d495b
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-04 10:51:06 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 15:02:23 +0900

    [ruby/rubygems] Require parent path source to contain matching specs before selecting it as replacement

    https://github.com/ruby/rubygems/commit/7c89d2588d

commit e6483d98907654d015ececd5de6a0079084f8f33
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-03 21:03:25 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 15:02:23 +0900

    [ruby/rubygems] Added failing example

    https://github.com/ruby/rubygems/commit/73735b503c

commit 779c3f928acd6d827b1d753ccb9e85c9e11e62bf
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-04 12:04:20 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-04 14:46:20 +0900

    Expand realpath to symlink when running with macOS

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16055

commit d26940e807844f9f64a964fbdc3ec6fb63998c58
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-04 14:02:17 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-04 14:40:49 +0900

    Revert "Comment out to disable ppc64le and s390x CI builds"

    This reverts commit e1655dad3a00a7b4026c653ff7c611811e7e34da.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16058

commit cb303ff4b82dca932cb7342e9f7fd337d69dc175
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-06 08:48:29 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:34 +0900

    [Bug #21669] Fix void value expression check for pattern-matching

    If the all `in` and `else` branches are void, the `case` is also void.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit baaf0ccb9c74d902d834c821c4d7e17e4bac4694
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 18:52:34 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:34 +0900

    [Bug #21669] Fix void value expression check for block

    A block containing a void statement that is not contained in a branch
    is also void.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit 35b95ec2e2c1b377cb884c706fd0836328e5a90f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 19:18:58 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:33 +0900

    [Bug #21669] Add more void value expression check for `if`

    If the both branches are void, the `if`/`unless` is also void.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit 932ce048feb9f26bcd9e8dc93ada4d2a407ace1f
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 19:01:21 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:33 +0900

    [Bug #21669] Implement void value expression check for `case`/`when`

    If the all `when` and `else` branches are void, the `case` is also
    void.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit 4f360107387c47bfd82e7010b8eb7393575d4d76
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 18:54:43 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:33 +0900

    [Bug #21669] Fix void value expression check for `rescue`-else

    If `rescue`-else node is void, the `rescue`-body is also void.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit c8b2a453d0fe099064e095d165ce38ee8c3eef38
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 18:52:34 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:33 +0900

    [Bug #21669] Fix void value expression check for `rescue`

    If any `rescue` node is non-void, the enclosing block is also
    non-void.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit 995c80bcd8509f59374506c04b60d94128cc2699
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-12-05 18:52:02 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 13:28:32 +0900

    Make `rb_node_case2_t` and `rb_node_case3_t` aliases of rb_node_case_t

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15498

commit 2ba2950d20e82f82017a52da9b09fdf1291479a2
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 17:37:05 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-04 12:40:59 +0900

    show loadavg if the test fails

    to survey the following failure:

    ```
      1) Failure:
    TestFile#test_stat [/tmp/ruby/src/trunk-repeat20/test/ruby/test_file.rb:412]:
    Expected |1770056232.744032 - 1770056230.6465776| (2.097454309463501) to be <= 1.
    ```

    BTW I found that `test/ruby/test_file.rb:412` `assert_in_delta atime, stat.atime.to_f, delta`
    only fails (mtime, ctime doesn't fail on 100 days).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16049

commit 2dc4e872e8bc6ee86ee734310970f66cc9dd51af
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-03 19:04:37 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 12:25:28 +0900

    [ruby/rubygems] Lock diff-lcs < 2.0

    https://github.com/ruby/rubygems/commit/23aecf4a86

commit 42c1d1dc8fa9ab6cb2b7f62745a02e683feef162
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-04 12:09:48 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-04 12:10:30 +0900

    add deps

commit c10b93cd5f04e1ae2fa34dd1bc3dc9e4de37a115
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-04 08:10:42 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-04 08:10:42 +0900

    tool: Support `$NO_COLOR` in `ifchange`

commit 3237be163c313af0b6626b209e55bdb0b33c9f0f
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-01-30 17:30:21 +0900
  Commit:     Kevin Newton <kddnewton@gmail.com>
  CommitDate: 2026-02-04 00:49:21 +0900

    [Bug #21669] Thoroughly implement void value expression check (prism)

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15999

commit 6a4e53f94ddc946b6116b250a2b20b78bef3f0ef
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-03 22:44:30 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 00:09:24 +0900

    [ruby/prism] Directly use `ruby_version` from `ruby/version.h`

    When I initially wrote this, I used `RUBY_VERSION` so it's easier to stub in tests
    But turns out that doesn't work in CRuby tests

    https://github.com/ruby/prism/commit/e30e2591de

commit ebef4dbae6cbbe636499c93d7ff0bf31dab88d18
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2026-01-30 04:48:08 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-04 00:09:23 +0900

    [ruby/prism] RB_GC_GUARD() the VALUE for RSTRING_PTR() to ensure the char* does not move

    * See https://github.com/ruby/prism/pull/3886#discussion_r2741579984.

    https://github.com/ruby/prism/commit/98603ce8cc

commit 4bf1cb087bc8ff065b6226037329d7464fa3e96c
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-03 20:10:01 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 21:33:30 +0900

    [ruby/prism] Better guard against syntax invalid code in ripper lex translator

    Closes https://github.com/ruby/prism/pull/3899

    Also better compatibility by only dropping
    the last token if it is actually EOF

    https://github.com/ruby/prism/commit/128ab52be9

commit cf22fe7f0857f0c980d9966047579b65c7798126
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-03 19:28:42 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-03 19:59:12 +0900

    Lock to install uutils-coreutils@0.5.0

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16050

commit f1201bcf1b6ff073f89e84bafe5040a5712dbbf5
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-03 17:27:47 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 18:18:09 +0900

    [ruby/rubygems] Update vendored resolv to 0.7.0

    https://github.com/ruby/rubygems/commit/844a05543b

commit 5ebccee59dc327ffb9e46a53cbe2ff853247fcd6
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 16:49:04 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 18:03:45 +0900

    check zeros

    raise when assert_linear_performance measures only zeros to check the following error:

    ```
      1) Error:
    TestRegexp#test_linear_performance:
    Test::Unit::ProxyError: nil can't be coerced into Integer
        /home/opc/ruby/src/master/test/ruby/test_regexp.rb:2301:in 'TestRegexp#test_linear_performance'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16047

commit f045a820edcf3a198c03b4eaa9a849418e31d469
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 17:09:56 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 17:42:22 +0900

    try to extend timeout

    for the following failure:

    ```
          1) Timeout:
        TestResolvDNS#test_multiple_servers_with_timeout_and_truncated_tcp_fallback
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16048

commit 2a57e636ae79711d7b4b2dd8fd754fa98629ce49
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 15:17:03 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 17:25:10 +0900

    try to extend timeout for repeated refine test

    for the following failure:
    ```
        1) Error:
      TestRefinement#test_refining_module_repeatedly:
      Test::Unit::ProxyError: execution of Test::Unit::CoreAssertions#assert_in_out_err expired timeout (10 sec)
      pid 56455 exit 0
      | ok
      |

          /Users/runner/work/ruby/ruby/src/test/ruby/test_refinement.rb:2258:in 'TestRefinement#test_refining_module_repeatedly'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16044

commit 8cb3663a54587fcb62242af11e0d96cccdf3ffed
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 15:27:03 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 17:24:45 +0900

    Try to send SEGV to show C bt

    for the following failure

    ```
        1) Error:
      TestClass#test_safe_multi_ractor_subclasses_list_mutation:
      Test::Unit::ProxyError: execution of Test::Unit::CoreAssertions#assert_separately expired timeout (10 sec)
      pid 814469 killed by SIGTERM (signal 15)
      |
          /tmp/ruby/src/trunk_gcc14/test/ruby/test_class.rb:922:in 'TestClass#test_safe_multi_ractor_subclasses_list_mutation'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16045

commit 07a0b68a85be84fa11ad63e60faeec4e4fd02490
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 15:02:16 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 17:17:19 +0900

    apply timeout scale in wait_exception

    to avoid such case:
    ```
      1) Failure:
    TestProcess#test_wait_exception [/tmp/ruby/src/trunk-asserts-nopara/test/ruby/test_process.rb:1588]:
    [ruby-dev:49176] [Bug #11340]: 3.696015712 seconds to interrupt Process.wait.
    Expected 3.696015712 to be < 3.
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16042

commit 25422c0d0733f50367c5533c7c4b326426848528
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 15:11:47 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 17:11:22 +0900

    use SIGSEGV on ractor timeout

    to show C level backtrace for the following failure:

    ```
      1) Error:
    TestObjSpaceRactor#test_undefine_finalizer:
    Test::Unit::ProxyError: execution of Test::Unit::CoreAssertions#assert_separately expired timeout (10 sec)
    pid 861177 killed by SIGTERM (signal 15)
    |
        /tmp/ruby/src/trunk-yjit/test/objspace/test_ractor.rb:17:in 'TestObjSpaceRactor#test_undefine_finalizer'
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16043

commit 2f8ab8e4703936f650d8dfc0ef69c174b6062761
  Author:     Koichi Sasada <ko1@atdot.net>
  AuthorDate: 2026-02-03 14:54:51 +0900
  Commit:     Koichi Sasada <ko1@atdot.net>
  CommitDate: 2026-02-03 17:07:32 +0900

    filter TracePoint :line events by file

    in target_thread test to avoid such failure:

    ```
    1) Failure:
      TestSetTraceFunc#test_enable_target_thread [/tmp/ruby/src/trunk/test/ruby/test_settracefunc.rb:2595]:
      <[#<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>]> expected but was
      <[#<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>,
       #<Thread:0x000078ca3d778460 run>]>.
    ```

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16041

commit 3820b354f1cbfbdeb60818a96de7b25995c5c1ac
  Author:     copilot-swe-agent[bot] <198982749+Copilot@users.noreply.github.com>
  AuthorDate: 2026-02-03 15:46:53 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-03 16:56:51 +0900

    Fix typo: wich → which in ractor.md

    Co-authored-by: hsbt <12301+hsbt@users.noreply.github.com>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16046

commit c0eca60eba638aa6bcb91f1b7d1467d697eec81d
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-03 16:39:10 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 16:50:19 +0900

    [ruby/json] Remove codepaths under !RUBY_INTEGER_UNIFICATION

    This was for pre Ruby 2.4 support which we dropped a while ago.

    https://github.com/ruby/json/commit/b11ce01ca6

commit 112c86e2640f596a4b7eeca6ebbe8c9909dfec08
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-03 16:35:11 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 16:36:54 +0900

    [ruby/json] Release 2.18.1

    https://github.com/ruby/json/commit/6ec6e7baff

commit 41238ccd85301b7d287a137d2fd8a94687f45784
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-03 03:44:02 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 16:24:37 +0900

    [ruby/json] fbuffer_append_str: assume string

    https://github.com/ruby/json/commit/fff25c9f4b

commit 066332465b927cf2d2b05d0d77014d7e3f48d933
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-03 06:06:44 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 16:24:29 +0900

    [ruby/json] Ensure `Generator::State` is kept on the stack

    Fix: https://github.com/ruby/json/issues/929

    When calling `cState_partial_generate` from `mHash_to_json` or other
    `to_json` funcs, `VState` becomes unreachable very quickly, hence the
    compiler may optimize it out of the stack, and make it invisible to
    the GC stack scanning. This is particularly liekly given how aggressively
    we inline.

    Repro:

    ```ruby
    require 'json'

    test_data = {
      "flag" => true,
      "data" => 10000.times.map { [1.0] },
      :flag => false,
    }

    10.times do
      test_data.to_json
    end
    ```

    But in practice the cause was just that the issued warning calls
    Hash#inspect on a big hash, which triggers GC.

    So it can be triggered even more reliably with:

    ```ruby
    require 'json'

    module JSON
      module Common
        def self.on_mixed_keys_hash(...)
          GC.start
        end
      end
    end

    test_data = {
      "flag" => true,
      "data" => 10000.times.map { [1.0] },
      :flag => false,
    }

    test_data.to_json
    ```

    https://github.com/ruby/json/commit/79b6e168ba

commit e1655dad3a00a7b4026c653ff7c611811e7e34da
  Author:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  AuthorDate: 2026-02-03 16:13:24 +0900
  Commit:     Hiroshi SHIBATA <hsbt@ruby-lang.org>
  CommitDate: 2026-02-03 16:13:24 +0900

    Comment out to disable ppc64le and s390x CI builds

    They are cancelled after new permission.

    https://github.com/IBM/actionspz/issues/75

    Other Ubuntu jobs unexpectedly terminated with their cancellation.

commit cf060ad6a6598edc58676dbbd49a78f733d5d499
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 13:02:13 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 13:06:46 +0900

    [ruby/resolv] [DOC] undocument private module/methods

    https://github.com/ruby/resolv/commit/73f6bb6edb

commit c00b50298f1ece10dcdb14e1afb4cb0037e5baa7
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 12:45:51 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 12:50:39 +0900

    [ruby/win32-registry] [DOC] document the namespace module

    https://github.com/ruby/win32-registry/commit/3de1a0b727

commit 184d4be89387fb94b4e85b313fc00d891c7f9244
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-03 12:41:44 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 12:44:27 +0900

    [ruby/timeout] [DOC] document the private instance method

    https://github.com/ruby/timeout/commit/52e85fed75

commit 99d90125c0d750478c74181809e0fe761ba34783
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-02 12:17:24 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-03 07:09:07 +0900

    [DOC] Improve docs for Coverage.start

commit c104ede5469cd3a9d78b651bbcf4b1eb16a0b9d4
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-02-02 23:50:09 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-02-03 06:18:15 +0900

    Make Ractor::Port embeddable

commit 03090e2e72f3308571db9c9b76b4126fc271d6ec
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-02 04:36:13 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 03:26:54 +0900

    [ruby/prism] Change `bin/prism errors` to take source and print errors

    This is more akin to how all the other ones work.
    Instead I added most of this to the errors test like focusing
    a few specifically and creating new expectations.

    https://github.com/ruby/prism/commit/b21922b0a1

commit 30d2e0cd6b94752e939025e2d5751f4b24e601ff
  Author:     Earlopain <14981592+Earlopain@users.noreply.github.com>
  AuthorDate: 2026-02-02 20:59:09 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 03:26:20 +0900

    [ruby/prism] Add escaping for doxygen token comment

    Many characters have special meaning and break formatting

    https://github.com/ruby/prism/commit/0b9d516c26

commit 997943219c2d44e60d1d7ae25c8f78c99ce6d970
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2026-01-28 04:01:27 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 02:06:08 +0900

    [ruby/openssl] Update the steps to generate the base64-based examples.

    * More precisely
    * Updating the rsa-1.pem file path.

    https://github.com/ruby/openssl/commit/d86270d1df

commit e690a8f39a121a2532586a321db7c4dfa1d867df
  Author:     Jun Aruga <jaruga@redhat.com>
  AuthorDate: 2026-01-19 22:23:24 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-03 02:06:08 +0900

    [ruby/openssl] Fix test_pkcs12.rb in FIPS.

    * OpenSSL::PKCS12.create calling the PKCS12_create() has the argument mac_iter
      which uses a MAC key using PKCS12KDF which is not FIPS-approved.
    * OpenSSL::PKCS12.new with base64-encoded example calling PKCS12_parse()
      verifies the MAC key using PKCS12KDF which is not FIPS-approved.
    * PBE-SHA1-3DES uses PKCS12KDF which is not FIPS-approved according to the RFC
      7292 PKCS#12.
      https://datatracker.ietf.org/doc/html/rfc7292#appendix-C
      > The PBES1 encryption scheme defined in PKCS #5 provides a number of
      > algorithm identifiers for deriving keys and IVs; here, we specify a
      > few more, all of which use the procedure detailed in Appendices B.2
      > and B.3 to construct keys (and IVs, where needed).  As is implied by
      > their names, all of the object identifiers below use the hash
      > function SHA-1.
      > ...
      > pbeWithSHAAnd3-KeyTripleDES-CBC  OBJECT IDENTIFIER ::= {pkcs-12PbeIds 3}

      Note that the pbeWithSHAAnd3-KeyTripleDES-CBC (pkcs12-pbeids 3) in the RFC
      7292 PKCS#12 means PBE-SHA1-3DES in OpenSSL. PKCS12KDF is used in PKCS#12.
      https://oidref.com/1.2.840.113549.1.12.1.3
      https://github.com/openssl/openssl/blob/ed57d1e06dca28689190e00d9893e0fd7ecc67c1/crypto/objects/objects.txt#L385

    https://github.com/ruby/openssl/commit/2aa6d97a54

commit a2ca4aa9ae9b917616b27d4605162003c7009269
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-03 00:40:21 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-03 01:17:06 +0900

    [DOC] Update incorrect class documentation

    `RCLASS_PRIME_CLASSEXT_PRIME_WRITABLE` doesn't exist, it's
    `RCLASS_PRIME_CLASSEXT_WRITABLE`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16038

commit 3cbdedb62095db19348355a5ab43d2a490012f40
  Author:     Étienne Barrié <etienne.barrie@gmail.com>
  AuthorDate: 2026-01-21 20:59:28 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-02 23:32:06 +0900

    Fix `VCS::GIT#export_changelog`

        + gmake RELNAME=master@0f1eea09490 AUTOCONF=autoconf dist
        /home/chkbuild/.rbenv/versions/3.4.8/bin/ruby --disable=gems  ./tool/make-snapshot \
        -srcdir=. -packages=gzip,zip,all \
        -unicode-version=17.0.0 \
        tmp master@0f1eea09490
        Exporting master@0f1eea09490
        Cloning into '/home/chkbuild/chkbuild/tmp/build/20260121T093003Z/tmp/ruby-snapshot20260121-3800606-t2y44s/ruby'...
        done.
        fatal: bad revision '#<struct VCS::GIT::Branch to_str="master">'
        fatal: bad revision '#<struct VCS::GIT::Branch to_str="master">'
        ./tool/make-snapshot:399: warning: no starting commit found

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15921

commit 9715b29a19c1fcb714b0de67ab373f808fb3ac9d
  Author:     Steven Webb <steve@buildkite.com>
  AuthorDate: 2026-01-11 22:13:27 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-02 14:00:17 +0900

    Update array.rb

    Co-authored-by: Nobuyoshi Nakada <nobu@ruby-lang.org>

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15846

commit 9368ec5e8b992856d554f57c56e4d5a9c45f0f38
  Author:     Steven Webb <steven.daniel.webb@gmail.com>
  AuthorDate: 2026-01-11 19:08:09 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-02 14:00:17 +0900

    Rewrite Array#find in ruby

    Inspired by https://bugs.ruby-lang.org/issues/20182 and https://github.com/ruby/ruby/pull/9533.

    This PR provides a performance boost to Array#find when run using JIT
    compilation. This is achieved by implementing Array#find in Ruby, which
    the JIT compiler can optimise.

    [PR#15189](https://github.com/ruby/ruby/pull/15189) added a C
    implementation for Array#find instead of relying on Enumerable#find.
    This PR extends this by adding a Ruby implementation.

    I used the so_fasta benchmark to measure performance. No change in
    interpreted performance before/after:

      $ benchmark-driver -e "~/.rubies/ruby-master/bin/ruby; ~/.rubies/ruby-array-find-native/bin/ruby" ../benchmark/so_fasta.rb
      Calculating -------------------------------------
                           ~/.rubies/ruby-master/bin/ruby   ~/.rubies/ruby-array-find-native/bin/ruby
                  so_fasta                          0.393                                       0.393 i/s -       1.000 times in 2.543209s 2.545514s

      Comparison:
                               so_fasta
      ~/.rubies/ruby-master/bin/ruby:         0.4 i/s
      ~/.rubies/ruby-array-find-native/bin/ruby:         0.4 i/s - 1.00x  slower

    With YJIT enabled Array#find is almost twice as fast:

      $ benchmark-driver -e "~/.rubies/ruby-array-find-native/bin/ruby; ~/.rubies/ruby-array-find-native/bin/ruby --yjit" ../benchmark/so_fasta.rb
      Calculating -------------------------------------
                           ~/.rubies/ruby-array-find-native/bin/ruby   ~/.rubies/ruby-array-find-native/bin/ruby --yjit
                  so_fasta                                     0.393                                              0.770 i/s -       1.000 times in 2.547550s 1.298371s

      Comparison:
                               so_fasta
      ~/.rubies/ruby-array-find-native/bin/ruby --yjit:         0.8 i/s
      ~/.rubies/ruby-array-find-native/bin/ruby:         0.4 i/s - 1.96x  slower

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15846

commit 70cc932d2791e885c1f085ca5fdd45ded09dd1a8
  Author:     Ian Ker-Seymer <ian.kerseymer@shopify.com>
  AuthorDate: 2026-02-02 02:45:43 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-02-02 13:55:42 +0900

    [ruby/rubygems] Fix nil `@revision` in `git_proxy.rb`

    https://github.com/ruby/rubygems/commit/69d955eb67

commit 34f848b366f72ef04a29097ed2e72e748ecbb4ae
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-01-31 07:11:59 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-02 12:12:29 +0900

    [DOC] Fix hash style in Hash#dig

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16013

commit 3ab35e5e2e9dfa156aa87d30a90a66593198400d
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-02 11:56:21 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-02 11:56:21 +0900

    [DOC] Doc for Module.new

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15962

    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 5cf4087000ea3d1c2249273bc4484c168df39842
  Author:     Alexander Bulancov <6594487+trinistr@users.noreply.github.com>
  AuthorDate: 2026-02-02 02:51:44 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-02 10:04:44 +0900

    [DOC] Fix typos in IO::Buffer's docs

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16032

commit 4e196af17c334de1eb74f7bb036fec12a35b794e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-02 05:19:10 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-02 05:57:59 +0900

    Use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16033

commit a93604b5ed813c43aca572ad64c1a7b66b715429
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-01 09:14:25 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-02 00:27:56 +0900

    [DOC] Fix dead links in options.md

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16028

commit 911c1ca2823601d4bcf6e0e9b5a40f1d4aae51bd
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-01 22:08:27 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-01 23:57:35 +0900

    Win32: keep --with-opt-dir as-is unless it is a real path

    Allow to expand environment variables in Makefile.

    E.g.:
    ```batch
    set VCPKG_INSTALLED=%HOME%\vcpkg\vcpkg_installed
    win32\configure.bat "--with-opt-dir=$(VCPKG_INSTALLED)/$(MACHINE)-windows"
    ```

commit 2ed817434f2958398773d8f3360a412fbf9384af
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-01 22:03:49 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-01 23:57:34 +0900

    Win32: strip double quotes from the batch file name

commit 24bdf6a40e58b172ce67ff61d0b966f194d96757
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 20:54:55 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 23:32:28 +0900

    transcode.c: Use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16031

commit 32f2596984c30a767b5a0b0d2d890a5653e17960
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 20:17:51 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 23:32:28 +0900

    thread_pthread.c: Use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16031

commit 1f58302e9f4810c0eb60c90b7933a30b5a0d05ff
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 20:39:24 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 23:32:28 +0900

    internal/gc.h: Remove inlined allocation decorator functions

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16031

commit 0a6e365fa036536a6fde88c430e50057264aad88
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 20:33:28 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 23:32:28 +0900

    eval_jump.c: Use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16031

commit 62da4806322091aa2586f9ec376bd0a70600a32a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 20:03:41 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 23:32:28 +0900

    vm_eval.c,vm_trace.c: Use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16031

commit 1276c233eac42d78016027a35b9e728427b215d2
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 06:57:35 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    thread.c: use ruby_sized_xfree for fdset and interupt tasks

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit 4d5cd811656bd34a68db9990bebd9fc75043780d
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 18:35:33 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    ractor_sync.c: use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit ecb28ce3ab49b8039680f1b1624abd4bddf4956c
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 18:26:00 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    prism_compile.c: use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit 9fa0cdc9239a9f56158d2c593780a1000444b82a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 18:10:44 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    vm_method.c: use sized free for css and method_definition

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit 44b5971e474e1975526c6792955af8457da8f4c1
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 18:05:21 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    string.c: use ruby_sized_xfree in a few more cases

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit d328412da84cdd26adb9a162bbf745bd43f7ee75
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 02:41:55 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    Use ruby_sized_xfree to free embedded Hash and Set

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit dc6cdb1759166630f29c456279c84fee1c0351d5
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 04:57:10 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    proc.c: use ruby_sized_xfree to free rb_binding_t

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit b39c1af417a27874373d8b936b535bcf8ec3276f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 03:08:47 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    cont.c: use ruby_sized_xfree to free the stack

    Also use mimalloc rather than raw malloc for `rb_jit_cont`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit 3fcd36ff5d149f05cab4cbade20bc40a59989740
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 02:29:39 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 20:17:29 +0900

    memory_view.c: Use ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16026

commit 3b2ad4b741a103d34fc309591ba9573989bb7888
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-01 17:37:33 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-02-01 17:37:33 +0900

    Check the suffix argument always if given

    It also must be ASCII-compatible and must not contain null byte, as
    well as the path argument.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16030

commit d90f78b567ffa6cde84d26d8594c771bd1e4bd86
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2026-02-01 11:33:45 +0900
  Commit:     Nobuyoshi Nakada <nobu.nakada@gmail.com>
  CommitDate: 2026-02-01 16:20:32 +0900

    Compare pointers with the end of path

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16029

commit 14ccd1515630de24d75ce31164a35cf74f57bde2
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-02-01 07:48:09 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-01 07:52:29 +0900

    [DOC] Fix broken links with slash character

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16027

commit 0796c9a3adc97e295625eba439340accf065a601
  Author:     Burdette Lamar <BurdetteLamar@Yahoo.com>
  AuthorDate: 2026-02-01 07:48:49 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-02-01 07:48:49 +0900

    [DOC] Remove unneeded link (#16014)

  Notes:
    Merged-By: peterzhu2118 <peter@peterzhu.ca>

commit 75d9c4c697eebc4485afbaa04544882ee301b687
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-01-31 11:35:02 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-01 07:45:40 +0900

    [DOC] Fix link in IO

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16017

commit 64f35adaadf8f168b46a3991914b87fa7b5feaa8
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-01-31 11:27:35 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-01 07:45:03 +0900

    [DOC] Fix link in Hash

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16016

commit 6019cc9dc07f6c31fa231325c2501b36fa4923fd
  Author:     BurdetteLamar <burdettelamar@yahoo.com>
  AuthorDate: 2026-01-31 11:17:17 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-02-01 07:44:45 +0900

    [DOC] Fix link in File

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16015

commit 66fdb15abf47df006a7cd29f34f30bec516f37aa
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 02:59:22 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 03:59:40 +0900

    thread_sync.c: Fix leak in Queue and SizedQueue

    This was introduced in 8ce61f90ba4aea3d52e92e258c3803b8b885726e

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16025

commit 4c1120b5fd67cdf15b8c790849e068851369852f
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 00:54:34 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 01:54:33 +0900

    ractor.c: Replace ruby_xfree by ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16023

commit 4292aed14bb9abb4233aa855e1d5ee89c02969f9
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-02-01 00:44:42 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 01:54:33 +0900

    string.c: Replace ruby_xfree by ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16023

commit 250fdd13c7a2e80bb4c58469dfc732e60a3a8b54
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 22:14:28 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 01:54:33 +0900

    iseq.c: Replace ruby_xfree by ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16023

commit 50e987bdca0f160412b27b97c8ef49d28b8c515e
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 21:00:06 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 01:54:33 +0900

    imemo.c: Replace ruby_xfree by ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16023

commit 9cc71cb9093caa7ee471def8aa8f0de596e366cf
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 19:02:17 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 01:54:33 +0900

    Use static memory instead of mimalloc for the VM, main ractor, main thread.

    Also allocate fibers with ruby_xmalloc.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16023

commit 0b4b30af9e09be12960ad1e9aff89b195b7c3734
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 15:21:17 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-02-01 01:54:33 +0900

    cont.c: Replace ruby_xfree by ruby_sized_xfree

    Notable exception for `fiber_free` because fibers are allocated
    with `ruby_mimmalloc`.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16023

commit 4ea3d8c773e62c3d808bb5f91e90bf8704926af4
  Author:     Steven Webb <steve@buildkite.com>
  AuthorDate: 2026-01-31 23:02:13 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-01-31 23:02:13 +0900

    [DOC] Example usage for --zjit-dump-hir (#16021)

    I found learning about the HIR format difficult because I couldn't get ruby/miniruby to output it using the --zjit-dump-hir option. I eventually realised it won't be generated unless the zjit-call-threshold is reached (default 30).

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit 7ef8c470d211af63b0898340074db373d55bc225
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-30 17:40:41 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-01-31 18:41:30 +0900

    Enable check for core data types by `RUBY_DEBUG`

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15352

commit eae7300a09a4b9bd87045b313dcdd464d12dd683
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-30 16:53:59 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-01-31 18:41:29 +0900

    Typed data check for core data types

  Notes:
    Merged: https://github.com/ruby/ruby/pull/15352

commit bd6fa7f5cca426901bc9162724966339440bc6cb
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 16:53:48 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    ruby_xfree: reject memory allocated by ruby_mimalloc

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit db52e98520349e2bfcd471a0c2f96d696a4f7498
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 15:03:17 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    compile.c: Replace ruby_xfree by ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit 54df6cddd79f0b04cfc3b2f33b9bb79897a4c78a
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 14:11:47 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    concurrent_set.c: Replace ruby_xfree by ruby_sized_xfree

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit a7d4a9df03f8b99432f7b1d58c3cd04dc639965c
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 13:43:49 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    class.c: Replace ruby_xfree by ruby_sized_xfree when applicable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit bcbc6ed57112e1e4ad76fb2db6c9c7b35685b890
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 13:28:52 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    bignum.c: Replace ruby_xfree by ruby_sized_xfree when applicable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit 0584f9fb0951bee3ea2645bdba0af56a2b320ed3
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-31 01:00:23 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    gc.c: Replace ruby_xfree by ruby_sized_xfree when applicable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit 050c00141c7e8fdded5355b4c31e971ae21403d0
  Author:     Jean Boussier <jean.boussier@gmail.com>
  AuthorDate: 2026-01-30 17:52:29 +0900
  Commit:     Jean Boussier <jean.boussier@gmail.com>
  CommitDate: 2026-01-31 18:35:48 +0900

    variable.c: Replace ruby_xfree by ruby_sized_xfree when applicable

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16010

commit 801cdfefe26da4381c10f994a9f103feae003f18
  Author:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  AuthorDate: 2025-11-30 16:56:44 +0900
  Commit:     Nobuyoshi Nakada <nobu@ruby-lang.org>
  CommitDate: 2026-01-31 17:51:34 +0900

    Fix wrong declaration of `rb_optimized_call`

    `recv` is used as the input argument to `GetProcPtr`, which is a
    `VALUE`.

    Fix up ruby/ruby#6691.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16022

commit 242850727c41244dcd60dffa3ec509476ade5212
  Author:     git[bot] <svn-admin@ruby-lang.org>
  AuthorDate: 2026-01-31 15:59:41 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-01-31 15:59:41 +0900

    Update bundled gems list as of 2026-01-31

commit 957887b3406b9ec50e67dbb7d7c1cdbc83d56c5d
  Author:     cui <cuiweixie@gmail.com>
  AuthorDate: 2026-01-31 13:33:44 +0900
  Commit:     GitHub <noreply@github.com>
  CommitDate: 2026-01-31 13:33:44 +0900

    [DOC] Fix typo: regsiter to register (#16020)

  Notes:
    Merged-By: tekknolagi <donotemailthisaddress@bernsteinbear.com>

commit e8d8f50fa82f1f05cc6fa927be7c3415f028e73c
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-01-21 04:55:36 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-01-31 12:42:26 +0900

    Clear age and unprotected bits for page at once

    This aims to speed up sweeping by clearing all age and wb_unprotected
    bits for unmarked objects. This should be faster because we can clear
    up to a whole plane of objects (64 slots) at once.

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16000

commit 6327f59307d8cd62438ed1fee80058b8c7cc5fab
  Author:     John Hawthorn <john@hawthorn.email>
  AuthorDate: 2026-01-21 03:47:21 +0900
  Commit:     John Hawthorn <john@hawthorn.email>
  CommitDate: 2026-01-31 12:42:26 +0900

    Use bit plane for age bits

    Previously we used two adjacent bits in the same word to store the
    object's age. This changes that to instead store the age in the same bit
    position across two adjacent words. This makes age use the exact same
    bit positions as the other bitmaps (just across two words).

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16000

commit 737809bf25e1c8babd3c8280a5fac162354f906b
  Author:     Peter Zhu <peter@peterzhu.ca>
  AuthorDate: 2026-01-31 07:05:11 +0900
  Commit:     Peter Zhu <peter@peterzhu.ca>
  CommitDate: 2026-01-31 07:10:33 +0900

    [DOC] Fix link in ARGF

  Notes:
    Merged: https://github.com/ruby/ruby/pull/16012

commit d7553015cc63258919f28b41c642eca66d35f8bf
  Author:     Benoit Daloze <eregontp@gmail.com>
  AuthorDate: 2026-01-30 04:39:23 +0900
  Commit:     git[bot] <svn-admin@ruby-lang.org>
  CommitDate: 2026-01-31 03:46:00 +0900

    [ruby/prism] Handle String-like objects for Ripper.sexp

    * RSpec relies on this in
      https://github.com/rspec/rspec/blob/rspec-support-v3.13.6/rspec-support/lib/rspec/support/source.rb#L57
      which is given an RSpec::Support::EncodedString.
